package VaxVoIP.VaxUserAgentLib;

import android.content.Context;
import VaxVoIP.VaxUserAgentLib.VaxUserAgentSIP.IVaxUserAgentSIP;
import VaxVoIP.VaxUserAgentLib.VaxUserAgentSIP.VaxUserAgentSIP;

public class VaxUserAgentLib implements IVaxUserAgentSIP
{
    public static final String VAX_TRIAL_LICENSE_KEY = "TRIAL-LICENSE-KEY";

    public static final int VAX_ACCOUNT_TYPE_UDP = 0;
    public static final int VAX_ACCOUNT_TYPE_TCP = 1;
    public static final int VAX_ACCOUNT_TYPE_TLS = 2;

    public static final int VAX_CAPTURE_SOUND_DEVICE_NONE = -2;

    public static final int VAX_VIDEO_QUALITY_LOW = 0;
    public static final int VAX_VIDEO_QUALITY_STANDARD = 1;
    public static final int VAX_VIDEO_QUALITY_MEDIUM = 2;
    public static final int VAX_VIDEO_QUALITY_HIGH = 3;
    public static final int VAX_VIDEO_QUALITY_MAX = 4;

    public static final int VAX_AUDIO_CODEC_TOTAL = 5;
    public static final int VAX_AUDIO_CODEC_G711U = 0;
    public static final int VAX_AUDIO_CODEC_G711A = 1;
    public static final int VAX_AUDIO_CODEC_GSM610 = 2;
    public static final int VAX_AUDIO_CODEC_ILBC = 3;
    public static final int VAX_AUDIO_CODEC_G729 = 4;

    public static final int VAX_VIDEO_CODEC_TOTAL = 1;
    public static final int VAX_VIDEO_CODEC_VP8 = 0;

    public static final int VAX_DTMF_TYPE_AUTO = 0;
    public static final int VAX_DTMF_TYPE_RFC2833 = 1;
    public static final int VAX_DTMF_TYPE_SIP_INFO = 2;
    public static final int VAX_DTMF_TYPE_INBAND = 3;

    public static final int VAX_CONTACT_STATUS_ONLINE = 0;
    public static final int VAX_CONTACT_STATUS_OFFLINE = 1;
    public static final int VAX_CONTACT_STATUS_AWAY = 2;
    public static final int VAX_CONTACT_STATUS_ON_PHONE = 3;
    public static final int VAX_CONTACT_STATUS_BUSY = 4;
    public static final int VAX_CONTACT_STATUS_UNKNOWN = 5;

    public static final int VAX_BUSY_LAMP_STATUS_FREE = 0;
    public static final int VAX_BUSY_LAMP_STATUS_OFFLINE = 1;
    public static final int VAX_BUSY_LAMP_STATUS_BUSY = 2;
    public static final int VAX_BUSY_LAMP_STATUS_UNKNOWN = 3;
    public static final int VAX_BUSY_LAMP_STATUS_CONNECTING = 4;

    public static final int VAX_CALL_HISTORY_TYPE_OUTBOUND = 0;
    public static final int VAX_CALL_HISTORY_TYPE_INBOUND = 1;
    public static final int VAX_CALL_HISTORY_TYPE_MISSED = 2;
    public static final int VAX_CALL_HISTORY_TYPE_REJECTED = 3;

    /////////////////////////////////////////////////////////////////////////////////////

    private Context mContext = null;
    private IVaxUserAgentLib mIVaxUserAgentLib = null;
    private VaxUserAgentSIP mVaxUserAgentSIP = null;

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public VaxUserAgentLib(Context objContext)
    {
        mContext = objContext;
        mIVaxUserAgentLib = null;

        mVaxUserAgentSIP = new VaxUserAgentSIP(this, objContext);
    }

    public VaxUserAgentLib(Context objContext, IVaxUserAgentLib iVaxUserAgentLib)
    {
        mContext = objContext;
        mIVaxUserAgentLib = iVaxUserAgentLib;

        mVaxUserAgentSIP = new VaxUserAgentSIP(this, objContext);
    }

    ////////////////////////////////////////////////////////////////////
    //////////////////////    METHODS     /////////////////////////////
    ///////////////////////////////////////////////////////////////////

    /*
    private void ShowMsg(Context context, String sMsg)
    {
        AlertDialog.Builder objBuilder = new AlertDialog.Builder(context);

        if (!sMsg.equals(""))
            objBuilder.setMessage(sMsg);

        objBuilder.setPositiveButton("OK", new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialogInterface, int i)
            {
                dialogInterface.dismiss();
            }
        });

        objBuilder.create();
        objBuilder.show();
    }
    */

    public boolean SetLicenceKey(String sKey)
    {
        //if(sKey == "TRIAL-LICENSE-KEY" || sKey.isEmpty())
        //  ShowMsg(objContextShowMsg, "VaxVoIP SDK is free to use for 30 days.\n\nIf you want to continue using it after the trial period, you must pay the License fee.\n\nThank you for using VaxVoIP SDK!\n\nWeb: www.vaxvoip.com\nEmail: info@vaxvoip.com");

        return mVaxUserAgentSIP.SetLicenceKey(sKey, mContext);
    }

    public boolean Initialize()
    {
        return mVaxUserAgentSIP.Initialize(mContext);
    }

    public void UnInitialize()
    {
        mVaxUserAgentSIP.UnInitialize();
    }

    public boolean DiagnosticLogSIP(String sAccountName, boolean bInbound, boolean bOutbound)
    {
        return mVaxUserAgentSIP.DiagnosticLogSIP(sAccountName, bInbound, bOutbound);
    }

    public boolean AddAccountSIP(String sAccountName, int nAccountType, String sListenIP, int nListenPort, String sDisplayName, String sUserName, String sAuthLogin, String sAuthPwd, String sDomainRealm, String sServerAddr, int nServerPort)
    {
        return mVaxUserAgentSIP.AddAccountSIP(sAccountName, nAccountType, sListenIP, nListenPort, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort);
    }

    public void RemoveAccountSIP(String sAccountName)
    {
        mVaxUserAgentSIP.RemoveAccountSIP(sAccountName);
    }

    public boolean DialCall(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo, int nInputDeviceId, int nOutputDeviceId)
    {
        return mVaxUserAgentSIP.DialCall(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo, nInputDeviceId, nOutputDeviceId);
    }

    public boolean DialCallToREC(String sAccountName, int nLineNo, String sDialNo)
    {
        return mVaxUserAgentSIP.DialCallToREC(sAccountName, nLineNo, sDialNo);
    }

    public boolean DisconnectCall(int nLineNo)
    {
        return mVaxUserAgentSIP.DisconnectCall(nLineNo);
    }

    public boolean AcceptCall(int nLineNo, String sCallId, int nInputDeviceId, int nOutputDeviceId)
    {
        return mVaxUserAgentSIP.AcceptCall(nLineNo, sCallId, nInputDeviceId, nOutputDeviceId);
    }

    public boolean RejectCall(String sCallId)
    {
        return mVaxUserAgentSIP.RejectCall(sCallId);
    }

    public boolean TransferCallBlind(int nLineNo, String sToUserName)
    {
        return mVaxUserAgentSIP.TransferCallBlind(nLineNo, sToUserName);
    }

    public boolean TransferCallConsult(int nLineNoA, int nLineNoB)
    {
        return mVaxUserAgentSIP.TransferCallConsult(nLineNoA, nLineNoB);
    }

    public boolean HoldLine(int nLineNo)
    {
        return mVaxUserAgentSIP.HoldLine(nLineNo);
    }

    public boolean UnHoldLine(int nLineNo)
    {
        return mVaxUserAgentSIP.UnHoldLine(nLineNo);
    }

    public boolean RefreshLine(int nLineNo)
    {
        return mVaxUserAgentSIP.RefreshLine(nLineNo);
    }

    public boolean RegisterAccountSIP(String sAccountName, int nExpire)
    {
        return mVaxUserAgentSIP.RegisterAccountSIP(sAccountName, nExpire);
    }

    public boolean UnRegisterAccountSIP(String sAccountName)
    {
        return mVaxUserAgentSIP.UnRegisterAccountSIP(sAccountName);
    }

    public boolean EnableKeepAlive(String sAccountName, int nSeconds)
    {
        return mVaxUserAgentSIP.EnableKeepAlive(sAccountName, nSeconds);
    }

    public void DisableKeepAlive(String sAccountName)
    {
        mVaxUserAgentSIP.DisableKeepAlive(sAccountName);
    }

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    public void DeselectAllAudioCodec()
    {
        mVaxUserAgentSIP.DeselectAllAudioCodec();
    }

    public void SelectAllAudioCodec()
    {
        mVaxUserAgentSIP.SelectAllAudioCodec();
    }

    public boolean SelectAudioCodec(int nCodecNo)
    {
        return mVaxUserAgentSIP.SelectAudioCodec(nCodecNo);
    }

    public boolean DeselectAudioCodec(int nCodecNo)
    {
        return mVaxUserAgentSIP.DeselectAudioCodec(nCodecNo);
    }

//////////////////////////////////////////////////////////////////////////////

    public void DeselectAllVideoCodec()
    {
        mVaxUserAgentSIP.DeselectAllVideoCodec();
    }

    public void SelectAllVideoCodec()
    {
        mVaxUserAgentSIP.SelectAllVideoCodec();
    }

    public boolean SelectVideoCodec(int nCodecNo)
    {
        return mVaxUserAgentSIP.SelectVideoCodec(nCodecNo);
    }

    public boolean DeselectVideoCodec(int nCodecNo)
    {
        return mVaxUserAgentSIP.DeselectVideoCodec(nCodecNo);
    }

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    public boolean OpenLineREC(int nLineNo, String sRTPRxIP, int nAudioPortRTP)
    {
        return mVaxUserAgentSIP.OpenLineREC(nLineNo, sRTPRxIP, nAudioPortRTP);
    }

    public boolean OpenLine(int nLineNo, String sRTPRxIP, int nRxAudioPortRTP, int nRxVideoPortRTP)
    {
        return mVaxUserAgentSIP.OpenLine(nLineNo, sRTPRxIP, nRxAudioPortRTP, nRxVideoPortRTP);
    }

    public boolean CloseLine(int nLineNo)
    {
        return mVaxUserAgentSIP.CloseLine(nLineNo);
    }

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    public boolean CryptoMediaNONE(boolean bForced)
    {
        return mVaxUserAgentSIP.CryptoMediaNONE(bForced);
    }

    public boolean CryptoMediaSDP(boolean bForced)
    {
        return mVaxUserAgentSIP.CryptoMediaSDP(bForced);
    }

    public int GetVaxErrorCode()
    {
        return mVaxUserAgentSIP.GetVaxErrorCode();
    }

    public String GetVaxErrorMsg()
    {
        return mVaxUserAgentSIP.GetVaxErrorMsg();
    }

    public boolean DigitDTMF(int nLineNo, String sDigit, int nTypeDTMF)
    {
        return mVaxUserAgentSIP.DigitDTMF(nLineNo, sDigit, nTypeDTMF);
    }

    public boolean SetVolumeDTMF(int nVolume)
    {
        return mVaxUserAgentSIP.SetVolumeDTMF(nVolume);
    }

    public int GetVolumeDTMF()
    {
        return mVaxUserAgentSIP.GetVolumeDTMF();
    }

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

    public boolean MuteMic(boolean bMute)
    {
        return mVaxUserAgentSIP.MuteMic(bMute);
    }

    public boolean MuteSpk(boolean bMute)
    {
        return mVaxUserAgentSIP.MuteSpk(bMute);
    }

    public boolean MuteLineSpk(int nLineNo, boolean bMute)
    {
        return mVaxUserAgentSIP.MuteLineSpk(nLineNo, bMute);
    }

    public boolean MuteLineMic(int nLineNo, boolean bMute)
    {
        return mVaxUserAgentSIP.MuteLineMic(nLineNo, bMute);
    }

    public boolean AutoGainMic(boolean bEnable, int nVolume)
    {
        return mVaxUserAgentSIP.AutoGainMic(bEnable, nVolume);
    }

    public boolean AutoGainSpk(boolean bEnable, int nVolume)
    {
        return mVaxUserAgentSIP.AutoGainSpk(bEnable, nVolume);
    }

    public boolean SetVolumeMic(int nVolume)
    {
        return mVaxUserAgentSIP.SetVolumeMic(nVolume);
    }

    public int GetVolumeMic()
    {
        return mVaxUserAgentSIP.GetVolumeMic();
    }

    public boolean SetVolumeSpk(int nVolume)
    {
        return mVaxUserAgentSIP.SetVolumeSpk(nVolume);
    }

    public int GetVolumeSpk()
    {
        return mVaxUserAgentSIP.GetVolumeSpk();
    }

    public boolean SetLineVolumeSpk(int nLineNo, int nVolume)
    {
        return mVaxUserAgentSIP.SetLineVolumeSpk(nLineNo, nVolume);
    }

    public int GetLineVolumeSpk(int nLineNo)
    {
        return mVaxUserAgentSIP.GetLineVolumeSpk(nLineNo);
    }

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

    public boolean IsLineOpen(int nLineNo)
    {
        return mVaxUserAgentSIP.IsLineOpen(nLineNo);
    }

    public boolean IsLineHold(int nLineNo)
    {
        return mVaxUserAgentSIP.IsLineHold(nLineNo);
    }

    public boolean IsLineBusy(int nLineNo)
    {
        return mVaxUserAgentSIP.IsLineBusy(nLineNo);
    }

    public boolean IsLineConnected(int nLineNo)
    {
        return mVaxUserAgentSIP.IsLineConnected(nLineNo);
    }

    public boolean IsLineRecording(int nLineNo)
    {
        return mVaxUserAgentSIP.IsLineRecording(nLineNo);
    }

    public boolean StartRecording(int nLineNo, String sFileName, int nTypeRecord, int nTypePCM)
    {
        return mVaxUserAgentSIP.StartRecording(nLineNo, sFileName, nTypeRecord, nTypePCM);
    }

    public boolean StopRecording(int nLineNo)
    {
        return mVaxUserAgentSIP.StopRecording(nLineNo);
    }

    public boolean ResetRecording(int nLineNo)
    {
        return mVaxUserAgentSIP.ResetRecording(nLineNo);
    }

    public boolean IsLinePlaying(int nLineNo)
    {
        return mVaxUserAgentSIP.IsLinePlaying(nLineNo);
    }

    public boolean PlayWaveOpen(int nLineNo, String sFileName)
    {
        return mVaxUserAgentSIP.PlayWaveOpen(nLineNo, sFileName);
    }

    public boolean PlayWaveClose(int nLineNo)
    {
        return mVaxUserAgentSIP.PlayWaveClose(nLineNo);
    }

    public boolean PlayWaveSkipTo(int nLineNo, int nMilliSeconds)
    {
        return mVaxUserAgentSIP.PlayWaveSkipTo(nLineNo, nMilliSeconds);
    }

    public int PlayWaveTotalTime(int nLineNo)
    {
        return mVaxUserAgentSIP.PlayWaveTotalTime(nLineNo);
    }

    public boolean PlayWavePause(int nLineNo)
    {
        return mVaxUserAgentSIP.PlayWavePause(nLineNo);
    }

    public boolean PlayWaveStart(int nLineNo, boolean bListen)
    {
        return mVaxUserAgentSIP.PlayWaveStart(nLineNo, bListen);
    }

    public boolean PlayWaveStop(int nLineNo)
    {
        return mVaxUserAgentSIP.PlayWaveStop(nLineNo);
    }

    public int PlayWavePosition(int nLineNo)
    {
        return mVaxUserAgentSIP.PlayWavePosition(nLineNo);
    }

    public boolean EchoCancellation(boolean bEnable)
    {
        return mVaxUserAgentSIP.EchoCancellation(bEnable);
    }

    public boolean DonotDisturb(boolean bEnable)
    {
        return mVaxUserAgentSIP.DonotDisturb(bEnable);
    }

    public boolean AudioDeviceVU(boolean bActivate, boolean bMicVU, boolean bSpkVU)
    {
        return mVaxUserAgentSIP.AudioDeviceVU(bActivate, bMicVU, bSpkVU);
    }

    public int GetAudioInDevTotal()
    {
        return mVaxUserAgentSIP.GetAudioInDevTotal();
    }

    public int GetAudioOutDevTotal()
    {
        return mVaxUserAgentSIP.GetAudioOutDevTotal();
    }

    public String GetAudioOutDevName(int nDeviceId)
    {
        return mVaxUserAgentSIP.GetAudioOutDevName(nDeviceId);
    }

    public String GetAudioInDevName(int nDeviceId)
    {
        return mVaxUserAgentSIP.GetAudioInDevName(nDeviceId);
    }

    public int GetOutboundCodec(int nLineNo)
    {
        return mVaxUserAgentSIP.GetOutboundCodec(nLineNo);
    }

    public int GetInboundCodec(int nLineNo)
    {
        return mVaxUserAgentSIP.GetInboundCodec(nLineNo);
    }

    public boolean AudioSessionLost(int nSeconds)
    {
        return mVaxUserAgentSIP.AudioSessionLost(nSeconds);
    }

    public boolean SetUserAgentSIP(String sUserAgentName)
    {
        return mVaxUserAgentSIP.SetUserAgentSIP(sUserAgentName);
    }

    public String GetUserAgentSIP()
    {
        return mVaxUserAgentSIP.GetUserAgentSIP();
    }

    public boolean SetSubjectSDP(String sSubjectSDP)
    {
        return mVaxUserAgentSIP.SetSubjectSDP(sSubjectSDP);
    }

    public String GetSubjectSDP()
    {
        return mVaxUserAgentSIP.GetSubjectSDP();
    }

    public boolean ConfAllowLine(int nLineNo, boolean bAllowListen, boolean bAllowSpeak)
    {
        return mVaxUserAgentSIP.ConfAllowLine(nLineNo, bAllowListen, bAllowSpeak);
    }

    public boolean ChatFindContact(String sAccountName, String sUserName)
    {
        return mVaxUserAgentSIP.ChatFindContact(sAccountName, sUserName);
    }

    public boolean ChatAddContact(String sAccountName, String sUserName, boolean bPresence)
    {
        return mVaxUserAgentSIP.ChatAddContact(sAccountName, sUserName, bPresence);
    }

    public boolean ChatRemoveContact(String sAccountName, String sUserName)
    {
        return mVaxUserAgentSIP.ChatRemoveContact(sAccountName, sUserName);
    }

    public boolean ChatSendMessageTyping(String sAccountName, String sUserName, int nUserValue)
    {
        return mVaxUserAgentSIP.ChatSendMessageTyping(sAccountName, sUserName, nUserValue);
    }

    public boolean ChatSendMessageText(String sAccountName, String sUserName, String sMsgText, boolean bMsgTypeHtml, int nUserValue)
    {
        return mVaxUserAgentSIP.ChatSendMessageText(sAccountName, sUserName, sMsgText, bMsgTypeHtml, nUserValue);
    }

    public boolean ChatSubscribeContactAll(String sAccountName)
    {
        return mVaxUserAgentSIP.ChatSubscribeContactAll(sAccountName);
    }

    public boolean ChatSetMyStatus(String sAccountName, int nStatusId)
    {
        return mVaxUserAgentSIP.ChatSetMyStatus(sAccountName, nStatusId);
    }

    public boolean VoiceChanger(int nPitch)
    {
        return mVaxUserAgentSIP.VoiceChanger(nPitch);
    }

    public boolean ForwardCall(boolean bEnable, String sToUserName)
    {
        return mVaxUserAgentSIP.ForwardCall(bEnable, sToUserName);
    }

    public boolean AddCustomHeader(int nLineNo, int nReqId, String sName, String sValue)
    {
        return mVaxUserAgentSIP.AddCustomHeader(nLineNo, nReqId, sName, sValue);
    }

    public boolean RemoveCustomHeader(int nLineNo, int nReqId, String sName)
    {
        return mVaxUserAgentSIP.RemoveCustomHeader(nLineNo, nReqId, sName);
    }

    public boolean RemoveCustomHeaderAll(int nLineNo, int nReqId)
    {
        return mVaxUserAgentSIP.RemoveCustomHeaderAll(nLineNo, nReqId);
    }

    public boolean AddCustomHeaderReferToURI(String sName, String sValue)
    {
        return mVaxUserAgentSIP.AddCustomHeaderReferToURI(sName, sValue);
    }

    public boolean RemoveCustomHeaderReferToURI(String sName)
    {
        return mVaxUserAgentSIP.RemoveCustomHeaderReferToURI(sName);
    }

    public boolean RemoveCustomHeaderAllReferToURI()
    {
        return mVaxUserAgentSIP.RemoveCustomHeaderAllReferToURI();
    }

    public int GetCountPacketLost(int nLineNo)
    {
        return mVaxUserAgentSIP.GetCountPacketLost(nLineNo);
    }

    public int GetSizeJitterBuffer(int nLineNo)
    {
        return mVaxUserAgentSIP.GetSizeJitterBuffer(nLineNo);
    }

    public int GetVideoDevTotal()
    {
        return mVaxUserAgentSIP.GetVideoDevTotal();
    }

    public String GetVideoDevName(int nDeviceId)
    {
        return mVaxUserAgentSIP.GetVideoDevName(nDeviceId);
    }

    public boolean OpenVideoDev(int nDeviceId, int nQuality)
    {
        return mVaxUserAgentSIP.OpenVideoDev(nDeviceId, nQuality);
    }

    public void CloseVideoDev()
    {
        mVaxUserAgentSIP.CloseVideoDev();
    }

////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

    public boolean DialRingEnable(String sFileName)
    {
        return mVaxUserAgentSIP.DialRingEnable(sFileName);
    }

    public boolean DialRingDisable()
    {
        return mVaxUserAgentSIP.DialRingDisable();
    }

    public boolean BusyRingEnable(String sFileName)
    {
        return mVaxUserAgentSIP.BusyRingEnable(sFileName);
    }

    public boolean BusyRingDisable()
    {
        return mVaxUserAgentSIP.BusyRingDisable();
    }

    public boolean EnableVideo(int nLineNo, boolean bOutbound, boolean bInbound)
    {
        return mVaxUserAgentSIP.EnableVideo(nLineNo, bOutbound, bInbound);
    }

    public boolean IsNetworkAvailable()
    {
        return mVaxUserAgentSIP.IsNetworkAvailable();
    }

    public boolean NetworkReachability(boolean bEnable)
    {
        return mVaxUserAgentSIP.NetworkReachability(bEnable);
    }

    public boolean AutoRegistration(String sAccountName, boolean bEnable, int nTickCountLimit, int nTickSeconds)
    {
        return mVaxUserAgentSIP.AutoRegistration(sAccountName, bEnable, nTickCountLimit, nTickSeconds);
    }

    public boolean VideoCodecBitRate(int nCodecNo, int nQuality)
    {
        return mVaxUserAgentSIP.VideoCodecBitRate(nCodecNo, nQuality);
    }

    public int BusyLampGetContactStatus(String sAccountName, String sUserName)
    {
        return mVaxUserAgentSIP.BusyLampGetContactStatus(sAccountName, sUserName);
    }

    public boolean BusyLampFindContact(String sAccountName, String sUserName)
    {
        return mVaxUserAgentSIP.BusyLampFindContact(sAccountName, sUserName);
    }

    public boolean BusyLampAddContact(String sAccountName, String sUserName)
    {
        return mVaxUserAgentSIP.BusyLampAddContact(sAccountName, sUserName);
    }

    public boolean BusyLampRemoveContact(String sAccountName, String sUserName)
    {
        return mVaxUserAgentSIP.BusyLampRemoveContact(sAccountName, sUserName);
    }

    public boolean BusyLampSubscribeContactAll(String sAccountName)
    {
        return mVaxUserAgentSIP.BusyLampSubscribeContactAll(sAccountName);
    }

    public boolean SetPushSIP(String sAccountName, String sProjectId, String sTokenReg)
    {
        return mVaxUserAgentSIP.SetPushSIP(sAccountName, sProjectId, sTokenReg);
    }

    public boolean AudioVAD(int nLineNo, boolean bEnable)
    {
        return mVaxUserAgentSIP.AudioVAD(nLineNo, bEnable);
    }

    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////


    ////////////////////////////////////////////////////////////////////
    //////////////////////    EVENTS      //////////////////////////////
    ///////////////////////////////////////////////////////////////////

    @Override
    public void OnInitialized()
    {
        mIVaxUserAgentLib.OnInitialized();
    }

    @Override
    public void OnUnInitialized()
    {
        mIVaxUserAgentLib.OnUnInitialized();
    }

    @Override
    public void OnConnectingToRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnConnectingToRegister(sAccountName);
    }

    @Override
    public void OnTryingToRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnTryingToRegister(sAccountName);
    }

    @Override
    public void OnFailToRegister(String sAccountName, int nStatusCode, String sReasonPhrase)
    {
        mIVaxUserAgentLib.OnFailToRegister(sAccountName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnSuccessToRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnSuccessToRegister(sAccountName);
    }

    @Override
    public void OnConnectingToReRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnConnectingToReRegister(sAccountName);
    }

    @Override
    public void OnTryingToReRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnTryingToReRegister(sAccountName);
    }

    @Override
    public void OnFailToReRegister(String sAccountName, int nStatusCode, String sReasonPhrase)
    {
        mIVaxUserAgentLib.OnFailToReRegister(sAccountName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnSuccessToReRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnSuccessToReRegister(sAccountName);
    }

    @Override
    public void OnTryingToUnRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnTryingToUnRegister(sAccountName);
    }

    @Override
    public void OnFailToUnRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnFailToUnRegister(sAccountName);
    }

    @Override
    public void OnSuccessToUnRegister(String sAccountName)
    {
        mIVaxUserAgentLib.OnSuccessToUnRegister(sAccountName);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void OnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo)
    {
        mIVaxUserAgentLib.OnDialCallStarted(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo);
    }

    @Override
    public void OnDialingCall(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase)
    {
        mIVaxUserAgentLib.OnDialingCall(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact)
    {
        mIVaxUserAgentLib.OnDialCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase, sContact);
    }

    @Override
    public void OnConnectedCall(String sAccountName, int nLineNo, String sToAddrRTP, int nToPortRTP)
    {
        mIVaxUserAgentLib.OnConnectedCall(sAccountName, nLineNo, sToAddrRTP, nToPortRTP);
    }

    @Override
    public void OnHungupCall(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnHungupCall(sAccountName, nLineNo);
    }

    @Override
    public void OnIncomingCallStarted(String sAccountName, String sCallId, String sCallerName, String sCallerId, String sDialNo, String sFromURI, String sToURI)
    {
        mIVaxUserAgentLib.OnIncomingCallStarted(sAccountName, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI);
    }

    @Override
    public void OnIncomingCallEnded(String sAccountName, String sCallId, int nReasonCode)
    {
        mIVaxUserAgentLib.OnIncomingCallEnded(sAccountName, sCallId, nReasonCode);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void OnTransferCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase)
    {
        mIVaxUserAgentLib.OnTransferCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnTransferCallAccepted(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnTransferCallAccepted(sAccountName, nLineNo);
    }

    @Override
    public void OnPlayWaveDone(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnPlayWaveDone(sAccountName, nLineNo);
    }

    @Override
    public void OnDigitDTMF(String sAccountName, int nLineNo, String sDigit)
    {
        mIVaxUserAgentLib.OnDigitDTMF(sAccountName, nLineNo, sDigit);
    }

    @Override
    public void OnMsgNOTIFY(String sAccountName, String sMsg)
    {
        mIVaxUserAgentLib.OnMsgNOTIFY(sAccountName, sMsg);
    }

    @Override
    public void OnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount)
    {
        mIVaxUserAgentLib.OnVoiceMailMsg(sAccountName, bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
    }

    @Override
    public void OnRingToneStarted(String sAccountName, String sCallId)
    {
        mIVaxUserAgentLib.OnRingToneStarted(sAccountName, sCallId);
    }

    @Override
    public void OnRingToneEnded(String sAccountName, String sCallId)
    {
        mIVaxUserAgentLib.OnRingToneEnded(sAccountName, sCallId);
    }

    @Override
    public void OnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort)
    {
        mIVaxUserAgentLib.OnIncomingDiagnostic(sAccountName, sMsgSIP, sFromIP, nFromPort);
    }

    @Override
    public void OnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort)
    {
        mIVaxUserAgentLib.OnOutgoingDiagnostic(sAccountName, sMsgSIP, sToIP, nToPort);
    }

    @Override
    public void OnAudioSessionLost(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnAudioSessionLost(sAccountName, nLineNo);
    }

    @Override
    public void OnSuccessToHold(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnSuccessToHold(sAccountName, nLineNo);
    }

    @Override
    public void OnTryingToHold(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnTryingToHold(sAccountName, nLineNo);
    }

    @Override
    public void OnFailToHold(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnFailToHold(sAccountName, nLineNo);
    }

    @Override
    public void OnSuccessToUnHold(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnSuccessToUnHold(sAccountName, nLineNo);
    }

    @Override
    public void OnTryingToUnHold(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnTryingToUnHold(sAccountName, nLineNo);
    }

    @Override
    public void OnFailToUnHold(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnFailToUnHold(sAccountName, nLineNo);
    }

    @Override
    public void OnTryingToRefresh(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnTryingToRefresh(sAccountName, nLineNo);
    }

    @Override
    public void OnFailToRefresh(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnFailToRefresh(sAccountName, nLineNo);
    }

    @Override
    public void OnSuccessToRefresh(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnSuccessToRefresh(sAccountName, nLineNo);
    }

    @Override
    public void OnChatSubscribeSuccess(String sAccountName, String sUserName)
    {
        mIVaxUserAgentLib.OnChatSubscribeSuccess(sAccountName, sUserName);
    }

    @Override
    public void OnChatSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase)
    {
        mIVaxUserAgentLib.OnChatSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnChatContactStatus(String sAccountName, String sUserName, int nStatusId)
    {
        mIVaxUserAgentLib.OnChatContactStatus(sAccountName, sUserName, nStatusId);
    }

    @Override
    public void OnChatSendMsgTextSuccess(String sAccountName, String sUserName, String sMsgText, int nUserValue)
    {
        mIVaxUserAgentLib.OnChatSendMsgTextSuccess(sAccountName, sUserName, sMsgText, nUserValue);
    }

    @Override
    public void OnChatSendMsgTextFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue)
    {
        mIVaxUserAgentLib.OnChatSendMsgTextFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue);
    }

    @Override
    public void OnChatSendMsgTypingSuccess(String sAccountName, String sUserName, int nUserValue)
    {
        mIVaxUserAgentLib.OnChatSendMsgTypingSuccess(sAccountName, sUserName, nUserValue);
    }

    @Override
    public void OnChatSendMsgTypingFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue)
    {
        mIVaxUserAgentLib.OnChatSendMsgTypingFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, nUserValue);
    }

    @Override
    public void OnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact)
    {
        mIVaxUserAgentLib.OnChatRecvMsgText(sAccountName, sUserName, sMsgText, bIsChatContact);
    }

    @Override
    public void OnChatRecvMsgTypingStart(String sAccountName, String sUserName)
    {
        mIVaxUserAgentLib.OnChatRecvMsgTypingStart(sAccountName, sUserName);
    }

    @Override
    public void OnChatRecvMsgTypingStop(String sAccountName, String sUserName)
    {
        mIVaxUserAgentLib.OnChatRecvMsgTypingStop(sAccountName, sUserName);
    }

    @Override
    public void OnAudioRecordedPCM(String sAccountName, int nLineNo, byte[] aDataPCM, int nSizePCM, int nTypePCM)
    {
        mIVaxUserAgentLib.OnAudioRecordedPCM(sAccountName, nLineNo, aDataPCM, nSizePCM, nTypePCM);
    }

    @Override
    public void OnHoldCall(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnHoldCall(sAccountName, nLineNo);
    }

    @Override
    public void OnUnHoldCall(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnUnHoldCall(sAccountName, nLineNo);
    }

    @Override
    public void OnVideoRemoteStarted(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnVideoRemoteStarted(sAccountName, nLineNo);
    }

    @Override
    public void OnVideoRemoteEnded(String sAccountName, int nLineNo)
    {
        mIVaxUserAgentLib.OnVideoRemoteEnded(sAccountName, nLineNo);
    }

    @Override
    public void OnVideoDeviceFrameRGB(int nDeviceId, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
    {
        mIVaxUserAgentLib.OnVideoDeviceFrameRGB(nDeviceId, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
    }

    @Override
    public void OnVideoRemoteFrameRGB(String sAccountName, int nLineNo, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
    {
        mIVaxUserAgentLib.OnVideoRemoteFrameRGB(sAccountName, nLineNo, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
    }

    @Override
    public void OnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId)
    {
        mIVaxUserAgentLib.OnAddCallHistory(sAccountName, bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
    }

    @Override
    public void OnNetworkReachability(boolean bAvailable)
    {
        mIVaxUserAgentLib.OnNetworkReachability(bAvailable);
    }

    @Override
    public void OnAudioDeviceMicVU(int nLevelVU)
    {
        mIVaxUserAgentLib.OnAudioDeviceMicVU(nLevelVU);
    }

    @Override
    public void OnAudioDeviceSpkVU(int nLevelVU)
    {
        mIVaxUserAgentLib.OnAudioDeviceSpkVU(nLevelVU);
    }

    @Override
    public void OnBusyLampSubscribeSuccess(String sAccountName, String sUserName)
    {
        mIVaxUserAgentLib.OnBusyLampSubscribeSuccess(sAccountName, sUserName);
    }

    @Override
    public void OnBusyLampSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase)
    {
        mIVaxUserAgentLib.OnBusyLampSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnBusyLampContactStatus(String sAccountName, String sUserName, int nStatusId)
    {
        mIVaxUserAgentLib.OnBusyLampContactStatus(sAccountName, sUserName, nStatusId);
    }

    @Override
    public void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode)
    {
        mIVaxUserAgentLib.OnVaxErrorMsg(sFuncName, sErrorMsg, nErrorCode);
    }
}
