package VaxVoIP.VaxUserAgentLib.VaxUserAgentSIP.AudioDevice;

import android.content.Context;
import android.media.AudioDeviceInfo;
import android.media.AudioManager;
import java.util.Timer;
import java.util.TimerTask;

public class AudioDevice extends AudioDeviceSO
{
    private Timer m_hTimerTick = null;
    int m_nActivatedDeviceType = -1;

    private Context mContext;

    public AudioDevice(Context objContext)
    {
        mContext = objContext;
    }

    ////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////

    public void OnInitialized()
    {
        StartTimer();
    }

    public void OnUnInitialized()
    {
        StopTimer();
    }

    ////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////

    private void StopTimer()
    {
        if(m_hTimerTick == null)
            return;

        m_hTimerTick.cancel();
        m_hTimerTick = null;
    }

    public void StartTimer()
    {
        StopTimer();

        m_hTimerTick = new Timer();
        m_hTimerTick.schedule(new TimerTask()
        {
            @Override
            public void run()
            {
                OnTimerTick();
            }

        }, 0, 2000);
    }

    ////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////

    private void OnTimerTick()
    {
        AudioManager objAudioMgr = (AudioManager) mContext.getSystemService(Context.AUDIO_SERVICE);

        AudioDeviceInfo hAudioDevice = objAudioMgr.getCommunicationDevice();

        if(hAudioDevice == null)
        {
            m_nActivatedDeviceType = -1;
            return;
        }

        if(m_nActivatedDeviceType == -1 || m_nActivatedDeviceType != hAudioDevice.getType())
        {
            m_nActivatedDeviceType = hAudioDevice.getType();

            super.AudioReset();
            return;
        }
    }

    ////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////

    public void AdjustCommunicationMode()
    {
        AudioManager objAudioMgr = (AudioManager) mContext.getSystemService(Context.AUDIO_SERVICE);
        objAudioMgr.setMode(AudioManager.MODE_IN_COMMUNICATION);
    }
}
