package VaxVoIP.VaxUserAgentLib.VaxUserAgentSIP;

public interface IVaxUserAgentSIP
{
     void OnInitialized();
     void OnUnInitialized();

     void OnConnectingToRegister(String sAccountName);
     void OnTryingToRegister(String sAccountName);

     void OnFailToRegister(String sAccountName, int nStatusCode, String sReasonPhrase);
     void OnSuccessToRegister(String sAccountName);

     void OnConnectingToReRegister(String sAccountName);
     void OnTryingToReRegister(String sAccountName);

     void OnFailToReRegister(String sAccountName, int nStatusCode, String sReasonPhrase);
     void OnSuccessToReRegister(String sAccountName);

     void OnTryingToUnRegister(String sAccountName);
     void OnFailToUnRegister(String sAccountName);
     void OnSuccessToUnRegister(String sAccountName);

     /////////////////////////////////////////////////////////////////////////////////////////
     /////////////////////////////////////////////////////////////////////////////////////////

     void OnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo);
     void OnDialingCall(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase);
     void OnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact);

     void OnConnectedCall(String sAccountName, int nLineNo, String sToAddrRTP, int nToPortRTP);
     void OnHungupCall(String sAccountName, int nLineNo);

     void OnIncomingCallStarted(String sAccountName, String sCallId, String sCallerName, String sCallerId, String sDialNo, String sFromURI, String sToURI);
     void OnIncomingCallEnded(String sAccountName, String sCallId, int nReasonCode);

     /////////////////////////////////////////////////////////////////////////////////////////
     /////////////////////////////////////////////////////////////////////////////////////////

     void OnTransferCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase);
     void OnTransferCallAccepted(String sAccountName, int nLineNo);

     void OnPlayWaveDone(String sAccountName, int nLineNo);
     void OnDigitDTMF(String sAccountName, int nLineNo, String sDigit);

     void OnMsgNOTIFY(String sAccountName, String sMsg);
     void OnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount);

     void OnRingToneStarted(String sAccountName, String sCallId);
     void OnRingToneEnded(String sAccountName, String sCallId);

     void OnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort);
     void OnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort);

     void OnAudioSessionLost(String sAccountName, int nLineNo);

     void OnSuccessToHold(String sAccountName, int nLineNo);
     void OnTryingToHold(String sAccountName, int nLineNo);
     void OnFailToHold(String sAccountName, int nLineNo);

     void OnSuccessToUnHold(String sAccountName, int nLineNo);
     void OnTryingToUnHold(String sAccountName, int nLineNo);
     void OnFailToUnHold(String sAccountName, int nLineNo);

     void OnTryingToRefresh(String sAccountName, int nLineNo);
     void OnFailToRefresh(String sAccountName, int nLineNo);
     void OnSuccessToRefresh(String sAccountName, int nLineNo);

     void OnChatSubscribeSuccess(String sAccountName, String sUserName);
     void OnChatSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase);

     void OnChatContactStatus(String sAccountName, String sUserName, int nStatusId);

     void OnChatSendMsgTextSuccess(String sAccountName, String sUserName, String sMsgText, int nUserValue);
     void OnChatSendMsgTextFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue);

     void OnChatSendMsgTypingSuccess(String sAccountName, String sUserName, int nUserValue);
     void OnChatSendMsgTypingFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue);

     void OnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact);
     void OnChatRecvMsgTypingStart(String sAccountName, String sUserName);
     void OnChatRecvMsgTypingStop(String sAccountName, String sUserName);

     void OnAudioRecordedPCM(String sAccountName, int nLineNo, byte[] aDataPCM, int nSizePCM, int nTypePCM);

     void OnHoldCall(String sAccountName, int nLineNo);
     void OnUnHoldCall(String sAccountName, int nLineNo);

     void OnVideoRemoteStarted(String sAccountName, int nLineNo);
     void OnVideoRemoteEnded(String sAccountName, int nLineNo);

     void OnVideoDeviceFrameRGB(int nDeviceId, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight);
     void OnVideoRemoteFrameRGB(String sAccountName, int nLineNo, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight);

     void OnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId);
     void OnNetworkReachability(boolean bAvailable);

     void OnAudioDeviceMicVU(int nLevelVU);
     void OnAudioDeviceSpkVU(int nLevelVU);

     void OnBusyLampSubscribeSuccess(String sAccountName, String sUserName);
     void OnBusyLampSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase);
     void OnBusyLampContactStatus(String sAccountName, String sUserName, int nStatusId);

     void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode);
}
