package VaxVoIP.VaxUserAgentLib.VaxUserAgentSIP.Network;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.ConnectivityManager.NetworkCallback;

import android.net.NetworkInfo;
import android.net.Network;

public class NetworkReceiver
{
    INetwork miNetwork = null;
    Context mContext = null;

    boolean mbLastAvailable = false;
    NetworkCallback mNetworkCallBack = null;

    public NetworkReceiver(INetwork iNetwork, Context objContext)
    {
        mContext = objContext;
        miNetwork = iNetwork;
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    public boolean IsNetworkAvailable()
    {
        return IsConnected();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    public void RegisterNetworkReceiver()
    {
        UnRegisterNetworkReciever();

        mbLastAvailable = IsConnected();
        RegisterCallBack();
    }

    public void UnRegisterNetworkReciever()
    {
        UnRegisterReciever();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    private void UnRegisterReciever()
    {
        if(mNetworkCallBack == null)
            return;

        ConnectivityManager hConnectivityManager = (ConnectivityManager) mContext.getSystemService(Context.CONNECTIVITY_SERVICE);
        hConnectivityManager.unregisterNetworkCallback(mNetworkCallBack);

        mNetworkCallBack = null;
    }

    private void RegisterCallBack()
    {
        try
        {
            ConnectivityManager hConnectivityManager = (ConnectivityManager) mContext.getSystemService(Context.CONNECTIVITY_SERVICE);
            //NetworkRequest.Builder builder = new NetworkRequest.Builder();

            mNetworkCallBack = new ConnectivityManager.NetworkCallback()
            {
                @Override
                public void onAvailable(Network network)
                {
                    OnNetworkReachability(true);
                }

                @Override
                public void onLost(Network network)
                {
                    OnNetworkReachability(false);
                }
            };

            hConnectivityManager.registerDefaultNetworkCallback(mNetworkCallBack);
        }
        catch (Exception e)
        {

        }
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    private boolean IsConnected()
    {
        ConnectivityManager hConnectivityManager = (ConnectivityManager) mContext.getSystemService(Context.CONNECTIVITY_SERVICE);

        NetworkInfo hNetworkInfo = hConnectivityManager != null ? hConnectivityManager.getActiveNetworkInfo() : null;

        if (hNetworkInfo == null)
            return false;

        return hNetworkInfo.isConnected();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    public void OnNetworkReachability(boolean bAvailable)
    {
        if(mbLastAvailable == bAvailable)
            return;

        mbLastAvailable = bAvailable;
        miNetwork.OnNetworkReachability(bAvailable);
    }
}
