package VaxVoIP.VaxUserAgentLib.VaxUserAgentSIP.Network;

import android.util.Log;

public abstract class NetworkSO
{
    private static NetworkSO m_objNetworkSO = null;

    static
    {
        try
        {
            System.loadLibrary("VaxUserAgentLib");
        }
        catch (UnsatisfiedLinkError e)
        {
            System.err.println("public native code library failed to load.\n" + e);
            Log.e("Tag", e.getMessage());
        }
    }

    NetworkSO()
    {
        m_objNetworkSO = this;

        OnCreatedNetworkOBJ();
    }

    ////////////////////////////////////////////////////////////////////
    //////////////////////  NATIVE METHODS   //////////////////////////
    ///////////////////////////////////////////////////////////////////

    public native void OnCreatedNetworkOBJ();
    public native void OnNetworkReachability(boolean bAvailable);

    ////////////////////////////////////////////////////////////////////
    //////////////////////  STATIC   EVENTS   //////////////////////////
    ///////////////////////////////////////////////////////////////////

    public static boolean PostNetworkReachability(boolean bEnable)
    {
        return m_objNetworkSO.NetworkReachability(bEnable);
    }

    public static boolean PostIsNetworkAvailable()
    {
        return m_objNetworkSO.IsNetworkAvailable();
    }

    /////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////

    protected abstract boolean NetworkReachability(boolean bEnable);
    protected abstract boolean IsNetworkAvailable();

}
