package VaxVoIP.VaxUserAgentLib.VaxUserAgentSIP.UserAgentSO;

import android.util.Log;

public abstract class VaxUserAgentSO
{
    private static VaxUserAgentSO m_objUserAgentSO = null;

    static
    {
        try
        {
            System.loadLibrary("VaxUserAgentLib");
        }
        catch (UnsatisfiedLinkError e)
        {
            System.err.println("public native code library failed to load.\n" + e);
            Log.e("Tag", e.getMessage());
        }
    }

    public VaxUserAgentSO()
    {
        m_objUserAgentSO = this;

        OnCreatedVaxUserAgentOBJ();
    }

    ////////////////////////////////////////////////////////////////////
    //////////////////////  NATIVE METHODS   //////////////////////////
    ///////////////////////////////////////////////////////////////////

    public native void OnCreatedVaxUserAgentOBJ();

    public native boolean SetLicenceKey(String sBindKey, Object objContext);

    public native String GetVersionFile();

    public native String GetVersionSDK();

    public native boolean Initialize(Object objContext);

    public native void UnInitialize();

    public native boolean DiagnosticLogSIP(String sAccountName, boolean bInbound, boolean bOutbound);

    public native boolean AddAccountSIP(String sAccountName, int nAccountType, String sListenIP, int nListenPort, String sDisplayName, String sUserName, String sAuthLogin, String sAuthPwd, String sDomainRealm, String sServerAddr, int nServerPort);

    public native void RemoveAccountSIP(String sAccountName);

    public native boolean RegisterAccountSIP(String sAccountName, int nExpire);

    public native boolean UnRegisterAccountSIP(String sAccountName);

    public native boolean OpenLine(int nLineNo, String sRTPRxIP, int nRxAudioPortRTP, int nRxVideoPortRTP);

    public native boolean OpenLineREC(int nLineNo, String sRTPRxIP, int nAudioPortRTP);

    public native boolean CloseLine(int nLineNo);

    public native boolean CryptoMediaNONE(boolean bForced);

    public native boolean CryptoMediaSDP(boolean bForced);

    public native int GetVaxErrorCode();

    public native String GetVaxErrorMsg();

    public native String GetCallId(int nLineNo);

    public native boolean AudioDeviceVU(boolean bActivate, boolean bMicVU, boolean bSpkVU);

    public native int GetAudioInDevTotal();

    public native int GetAudioOutDevTotal();

    public native String GetAudioInDevName(int nDeviceId);

    public native String GetAudioOutDevName(int nDeviceId);

    public native boolean DialCall(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo, int nInputDeviceId, int nOutputDeviceId);

    public native boolean DialCallToREC(String sAccountName, int nLineNo, String sDialNo);

    public native boolean DisconnectCall(int nLineNo);

    public native boolean AcceptCall(int nLineNo, String sCallId, int nInputDeviceId, int nOutputDeviceId);

    public native boolean RejectCall(String sCallId);

    public native boolean TransferCallBlind(int nLineNo, String sToUserName);

    public native boolean TransferCallConsult(int nLineNoA, int nLineNoB);

    public native boolean HoldLine(int nLineNo);

    public native boolean UnHoldLine(int nLineNo);

    public native boolean RefreshLine(int nLineNo);

    public native boolean IsLineOpen(int nLineNo);

    public native boolean IsLineHold(int nLineNo);

    public native boolean IsLineBusy(int nLineNo);

    public native boolean IsLineConnected(int nLineNo);

    public native boolean EnableKeepAlive(String sAccountName, int nSeconds);

    public native void DisableKeepAlive(String sAccountName);

    public native void DeselectAllAudioCodec();

    public native void SelectAllAudioCodec();

    public native boolean SelectAudioCodec(int nCodecNo);

    public native boolean DeselectAudioCodec(int nCodecNo);

    public native void DeselectAllVideoCodec();

    public native void SelectAllVideoCodec();

    public native boolean SelectVideoCodec(int nCodecNo);

    public native boolean DeselectVideoCodec(int nCodecNo);

    public native boolean DigitDTMF(int nLineNo, String sDigit, int nTypeDTMF);

    public native boolean SetVolumeDTMF(int nVolume);

    public native int GetVolumeDTMF();

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    public native boolean MuteMic(boolean bMute);

    public native boolean MuteSpk(boolean bMute);

    public native boolean MuteLineSpk(int nLineNo, boolean bMute);

    public native boolean MuteLineMic(int nLineNo, boolean bMute);

    public native boolean AutoGainMic(boolean bEnable, int nVolume);

    public native boolean AutoGainSpk(boolean bEnable, int nVolume);

    public native boolean SetVolumeMic(int nVolume);

    public native int GetVolumeMic();

    public native boolean SetVolumeSpk(int nVolume);

    public native int GetVolumeSpk();

    public native boolean SetLineVolumeSpk(int nLineNo, int nVolume);

    public native int GetLineVolumeSpk(int nLineNo);

    /*
    public native boolean SpeakerPhone(Boolean bEnable);

    public native boolean IsSpeakerPhone();
    */

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    public native boolean EchoCancellation(boolean bEnable);

    public native boolean DonotDisturb(boolean bEnable);

    public native boolean IsLineRecording(int nLineNo);

    public native boolean StartRecording(int nLineNo, String sFileName, int nTypeRecord, int nTypePCM);

    public native boolean StopRecording(int nLineNo);

    public native boolean ResetRecording(int nLineNo);

    public native boolean IsLinePlaying(int nLineNo);

    public native boolean PlayWaveOpen(int nLineNo, String sFileName);

    public native boolean PlayWaveClose(int nLineNo);

    public native boolean PlayWaveSkipTo(int nLineNo, int nMilliSeconds);

    public native int PlayWaveTotalTime(int nLineNo);

    public native boolean PlayWavePause(int nLineNo);

    public native boolean PlayWaveStart(int nLineNo, boolean bListen);

    public native boolean PlayWaveStop(int nLineNo);

    public native int PlayWavePosition(int nLineNo);

    public native int GetOutboundCodec(int nLineNo);

    public native int GetInboundCodec(int nLineNo);

    public native boolean AudioSessionLost(int nSeconds);

    public native boolean SetUserAgentSIP(String sUserAgentName);

    public native String GetUserAgentSIP();

    public native boolean SetSubjectSDP(String sSubjectSDP);

    public native String GetSubjectSDP();

    public native boolean ConfAllowLine(int nLineNo, boolean bAllowListen, boolean bAllowSpeak);

    public native boolean ChatFindContact(String sAccountName, String sUserName);

    public native boolean ChatAddContact(String sAccountName, String sUserName, boolean bPresence);

    public native boolean ChatRemoveContact(String sAccountName, String sUserName);

    public native boolean ChatSendMessageTyping(String sAccountName, String sUserName, int nUserValue);

    public native boolean ChatSendMessageText(String sAccountName, String sUserName, String sMsgText, boolean bMsgTypeHtml, int nUserValue);

    public native boolean ChatSubscribeContactAll(String sAccountName);

    public native boolean ChatSetMyStatus(String sAccountName, int nStatusId);

    public native boolean VoiceChanger(int nPitch);

    public native boolean ForwardCall(boolean bEnable, String sToUserName);

    public native boolean PlayAddPCM(int nLineNo, char[] aDataPCM, int nSizePCM);

    public native boolean PlayResetPCM(int nLineNo);

    public native boolean AddCustomHeader(int nLineNo, int nReqId, String sName, String sValue);

    public native boolean RemoveCustomHeader(int nLineNo, int nReqId, String sName);

    public native boolean RemoveCustomHeaderAll(int nLineNo, int nReqId);

    public native boolean AddCustomHeaderReferToURI(String sName, String sValue);

    public native boolean RemoveCustomHeaderReferToURI(String sName);

    public native boolean RemoveCustomHeaderAllReferToURI();

    public native boolean ActivateQosSIP(int nPriorityQos);

    public native void DeactivateQosSIP();

    public native boolean ActivateQosRTP(int nLineNo, int nPriorityQos);

    public native void DeactivateQosRTP(int nLineNo);

    public native int GetCountPacketLost(int nLineNo);

    public native int GetSizeJitterBuffer(int nLineNo);

    public native int GetVideoDevTotal();

    public native String GetVideoDevName(int nDeviceId);

    public native boolean OpenVideoDev(int nDeviceId, int nQuality);

    public native void CloseVideoDev();

    public native boolean DialRingEnable(String sFileName);

    public native boolean DialRingDisable();

    public native boolean BusyRingEnable(String sFileName);

    public native boolean BusyRingDisable();

    public native boolean EnableVideo(int nLineNo, boolean bOutbound, boolean bInbound);

    public native boolean IsNetworkAvailable();

    public native boolean NetworkReachability(boolean bEnable);

    public native boolean AutoRegistration(String sAccountName, boolean bEnable, int nTryCount, int nTryAfterSeconds);

    public native boolean VideoCodecBitRate(int nCodecNo, int nQuality);

    public native int BusyLampGetContactStatus(String sAccountName, String sUserName);

    public native boolean BusyLampFindContact(String sAccountName, String sUserName);

    public native boolean BusyLampAddContact(String sAccountName, String sUserName);

    public native boolean BusyLampRemoveContact(String sAccountName, String sUserName);

    public native boolean BusyLampSubscribeContactAll(String sAccountName);

    public native boolean SetPushSIP(String sAccountName, String sProjectId, String sTokenReg);

    public native boolean AudioVAD(int nLineNo, boolean bEnable);

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public static void PostOnInitialized() {
        m_objUserAgentSO.OnInitialized();
    }

    public static void PostOnUnInitialized() {
        m_objUserAgentSO.OnUnInitialized();
    }

    public static void PostOnConnectingToRegister(String sAccountName) {
        m_objUserAgentSO.OnConnectingToRegister(sAccountName);
    }

    public static void PostOnTryingToRegister(String sAccountName) {
        m_objUserAgentSO.OnTryingToRegister(sAccountName);
    }

    public static void PostOnFailToRegister(String sAccountName, int nStatusCode, String sReasonPhrase) {
        m_objUserAgentSO.OnFailToRegister(sAccountName, nStatusCode, sReasonPhrase);
    }

    public static void PostOnSuccessToRegister(String sAccountName) {
        m_objUserAgentSO.OnSuccessToRegister(sAccountName);
    }

    public static void PostOnConnectingToReRegister(String sAccountName) {
        m_objUserAgentSO.OnConnectingToReRegister(sAccountName);
    }

    public static void PostOnTryingToReRegister(String sAccountName) {
        m_objUserAgentSO.OnTryingToReRegister(sAccountName);
    }

    public static void PostOnFailToReRegister(String sAccountName, int nStatusCode, String sReasonPhrase) {
        m_objUserAgentSO.OnFailToReRegister(sAccountName, nStatusCode, sReasonPhrase);
    }

    public static void PostOnSuccessToReRegister(String sAccountName) {
        m_objUserAgentSO.OnSuccessToReRegister(sAccountName);
    }

    public static void PostOnTryingToUnRegister(String sAccountName) {
        m_objUserAgentSO.OnTryingToUnRegister(sAccountName);
    }

    public static void PostOnFailToUnRegister(String sAccountName) {
        m_objUserAgentSO.OnFailToUnRegister(sAccountName);
    }

    public static void PostOnSuccessToUnRegister(String sAccountName) {
        m_objUserAgentSO.OnSuccessToUnRegister(sAccountName);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    public static void PostOnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo) {
        m_objUserAgentSO.OnDialCallStarted(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo);
    }

    public static void PostOnDialingCall(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase) {
        m_objUserAgentSO.OnDialingCall(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
    }

    public static void PostOnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact) {
        m_objUserAgentSO.OnDialCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase, sContact);
    }

    public static void PostOnConnectedCall(String sAccountName, int nLineNo, String sToAddrRTP, int nToPortRTP) {
        m_objUserAgentSO.OnConnectedCall(sAccountName, nLineNo, sToAddrRTP, nToPortRTP);
    }

    public static void PostOnHungupCall(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnHungupCall(sAccountName, nLineNo);
    }

    public static void PostOnIncomingCallStarted(String sAccountName, String sCallId, String sCallerName, String sCallerId, String sDialNo, String sFromURI, String sToURI) {
        m_objUserAgentSO.OnIncomingCallStarted(sAccountName, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI);
    }

    public static void PostOnIncomingCallEnded(String sAccountName, String sCallId, int nReasonCode) {
        m_objUserAgentSO.OnIncomingCallEnded(sAccountName, sCallId, nReasonCode);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    public static void PostOnTransferCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase) {
        m_objUserAgentSO.OnTransferCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
    }

    public static void PostOnTransferCallAccepted(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnTransferCallAccepted(sAccountName, nLineNo);
    }

    public static void PostOnPlayWaveDone(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnPlayWaveDone(sAccountName, nLineNo);
    }

    public static void PostOnDigitDTMF(String sAccountName, int nLineNo, String sDigit) {
        m_objUserAgentSO.OnDigitDTMF(sAccountName, nLineNo, sDigit);
    }

    public static void PostOnMsgNOTIFY(String sAccountName, String sMsg) {
        m_objUserAgentSO.OnMsgNOTIFY(sAccountName, sMsg);
    }

    public static void PostOnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount) {
        m_objUserAgentSO.OnVoiceMailMsg(sAccountName, bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
    }

    public static void PostOnRingToneStarted(String sAccountName, String sCallId) {
        m_objUserAgentSO.OnRingToneStarted(sAccountName, sCallId);
    }

    public static void PostOnRingToneEnded(String sAccountName, String sCallId) {
        m_objUserAgentSO.OnRingToneEnded(sAccountName, sCallId);
    }

    public static void PostOnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort) {
        m_objUserAgentSO.OnIncomingDiagnostic(sAccountName, sMsgSIP, sFromIP, nFromPort);
    }

    public static void PostOnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort) {
        m_objUserAgentSO.OnOutgoingDiagnostic(sAccountName, sMsgSIP, sToIP, nToPort);
    }

    public static void PostOnAudioSessionLost(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnAudioSessionLost(sAccountName, nLineNo);
    }

    public static void PostOnSuccessToHold(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnSuccessToHold(sAccountName, nLineNo);
    }

    public static void PostOnTryingToHold(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnTryingToHold(sAccountName, nLineNo);
    }

    public static void PostOnFailToHold(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnFailToHold(sAccountName, nLineNo);
    }

    public static void PostOnSuccessToUnHold(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnSuccessToUnHold(sAccountName, nLineNo);
    }

    public static void PostOnTryingToUnHold(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnTryingToUnHold(sAccountName, nLineNo);
    }

    public static void PostOnFailToUnHold(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnFailToUnHold(sAccountName, nLineNo);
    }

    public static void PostOnTryingToRefresh(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnTryingToRefresh(sAccountName, nLineNo);
    }

    public static void PostOnFailToRefresh(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnFailToRefresh(sAccountName, nLineNo);
    }

    public static void PostOnSuccessToRefresh(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnSuccessToRefresh(sAccountName, nLineNo);
    }

    public static void PostOnChatSubscribeSuccess(String sAccountName, String sUserName) {
        m_objUserAgentSO.OnChatSubscribeSuccess(sAccountName, sUserName);
    }

    public static void PostOnChatSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase) {
        m_objUserAgentSO.OnChatSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
    }

    public static void PostOnChatContactStatus(String sAccountName, String sUserName, int nStatusId) {
        m_objUserAgentSO.OnChatContactStatus(sAccountName, sUserName, nStatusId);
    }

    public static void PostOnChatSendMsgTextSuccess(String sAccountName, String sUserName, String sMsgText, int nUserValue) {
        m_objUserAgentSO.OnChatSendMsgTextSuccess(sAccountName, sUserName, sMsgText, nUserValue);
    }

    public static void PostOnChatSendMsgTextFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue) {
        m_objUserAgentSO.OnChatSendMsgTextFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue);
    }

    public static void PostOnChatSendMsgTypingSuccess(String sAccountName, String sUserName, int nUserValue) {
        m_objUserAgentSO.OnChatSendMsgTypingSuccess(sAccountName, sUserName, nUserValue);
    }

    public static void PostOnChatSendMsgTypingFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue) {
        m_objUserAgentSO.OnChatSendMsgTypingFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, nUserValue);
    }

    public static void PostOnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact) {
        m_objUserAgentSO.OnChatRecvMsgText(sAccountName, sUserName, sMsgText, bIsChatContact);
    }

    public static void PostOnChatRecvMsgTypingStart(String sAccountName, String sUserName) {
        m_objUserAgentSO.OnChatRecvMsgTypingStart(sAccountName, sUserName);
    }

    public static void PostOnChatRecvMsgTypingStop(String sAccountName, String sUserName) {
        m_objUserAgentSO.OnChatRecvMsgTypingStop(sAccountName, sUserName);
    }

    public static void PostOnAudioRecordedPCM(String sAccountName, int nLineNo, byte[] aDataPCM, int nSizePCM, int nTypePCM) {
        m_objUserAgentSO.OnAudioRecordedPCM(sAccountName, nLineNo, aDataPCM, nSizePCM, nTypePCM);
    }

    public static void PostOnHoldCall(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnHoldCall(sAccountName, nLineNo);
    }

    public static void PostOnUnHoldCall(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnUnHoldCall(sAccountName, nLineNo);
    }

    public static void PostOnVideoRemoteStarted(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnVideoRemoteStarted(sAccountName, nLineNo);
    }

    public static void PostOnVideoRemoteEnded(String sAccountName, int nLineNo) {
        m_objUserAgentSO.OnVideoRemoteEnded(sAccountName, nLineNo);
    }

    public static void PostOnVideoDeviceFrameRGB(int nDeviceId, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight) {
        m_objUserAgentSO.OnVideoDeviceFrameRGB(nDeviceId, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
    }

    public static void PostOnVideoRemoteFrameRGB(String sAccountName, int nLineNo, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight) {
        m_objUserAgentSO.OnVideoRemoteFrameRGB(sAccountName, nLineNo, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
    }

    public static void PostOnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId) {
        m_objUserAgentSO.OnAddCallHistory(sAccountName, bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
    }

    public static void PostOnNetworkReachability(boolean bAvailable) {
        m_objUserAgentSO.OnNetworkReachability(bAvailable);
    }

    public static void PostOnAudioDeviceMicVU(int nLevelVU) {
        m_objUserAgentSO.OnAudioDeviceMicVU(nLevelVU);
    }

    public static void PostOnAudioDeviceSpkVU(int nLevelVU) {
        m_objUserAgentSO.OnAudioDeviceSpkVU(nLevelVU);
    }

    public static void PostOnBusyLampSubscribeSuccess(String sAccountName, String sUserName) {
        m_objUserAgentSO.OnBusyLampSubscribeSuccess(sAccountName, sUserName);
    }

    public static void PostOnBusyLampSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase) {
        m_objUserAgentSO.OnBusyLampSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
    }

    public static void PostOnBusyLampContactStatus(String sAccountName, String sUserName, int nStatusId) {
        m_objUserAgentSO.OnBusyLampContactStatus(sAccountName, sUserName, nStatusId);
    }

    public static void PostOnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode) {
        m_objUserAgentSO.OnVaxErrorMsg(sFuncName, sErrorMsg, nErrorCode);
    }

    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////

    protected abstract void OnInitialized();

    protected abstract void OnUnInitialized();

    protected abstract void OnConnectingToRegister(String sAccountName);

    protected abstract void OnTryingToRegister(String sAccountName);

    protected abstract void OnFailToRegister(String sAccountName, int nStatusCode, String sReasonPhrase);

    protected abstract void OnSuccessToRegister(String sAccountName);

    protected abstract void OnConnectingToReRegister(String sAccountName);

    protected abstract void OnTryingToReRegister(String sAccountName);

    protected abstract void OnFailToReRegister(String sAccountName, int nStatusCode, String sReasonPhrase);

    protected abstract void OnSuccessToReRegister(String sAccountName);

    protected abstract void OnTryingToUnRegister(String sAccountName);

    protected abstract void OnFailToUnRegister(String sAccountName);

    protected abstract void OnSuccessToUnRegister(String sAccountName);

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    protected abstract void OnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo);

    protected abstract void OnDialingCall(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase);

    protected abstract void OnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact);

    protected abstract void OnConnectedCall(String sAccountName, int nLineNo, String sToAddrRTP, int nToPortRTP);

    protected abstract void OnHungupCall(String sAccountName, int nLineNo);

    protected abstract void OnIncomingCallStarted(String sAccountName, String sCallId, String sCallerName, String sCallerId, String sDialNo, String sFromURI, String sToURI);

    protected abstract void OnIncomingCallEnded(String sAccountName, String sCallId, int nReasonCode);

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    protected abstract void OnTransferCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase);

    protected abstract void OnTransferCallAccepted(String sAccountName, int nLineNo);

    protected abstract void OnPlayWaveDone(String sAccountName, int nLineNo);

    protected abstract void OnDigitDTMF(String sAccountName, int nLineNo, String sDigit);

    protected abstract void OnMsgNOTIFY(String sAccountName, String sMsg);

    protected abstract void OnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount);

    protected abstract void OnRingToneStarted(String sAccountName, String sCallId);

    protected abstract void OnRingToneEnded(String sAccountName, String sCallId);

    protected abstract void OnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort);

    protected abstract void OnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort);

    protected abstract void OnAudioSessionLost(String sAccountName, int nLineNo);

    protected abstract void OnSuccessToHold(String sAccountName, int nLineNo);

    protected abstract void OnTryingToHold(String sAccountName, int nLineNo);

    protected abstract void OnFailToHold(String sAccountName, int nLineNo);

    protected abstract void OnSuccessToUnHold(String sAccountName, int nLineNo);

    protected abstract void OnTryingToUnHold(String sAccountName, int nLineNo);

    protected abstract void OnFailToUnHold(String sAccountName, int nLineNo);

    protected abstract void OnTryingToRefresh(String sAccountName, int nLineNo);

    protected abstract void OnFailToRefresh(String sAccountName, int nLineNo);

    protected abstract void OnSuccessToRefresh(String sAccountName, int nLineNo);

    protected abstract void OnChatSubscribeSuccess(String sAccountName, String sUserName);

    protected abstract void OnChatSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase);

    protected abstract void OnChatContactStatus(String sAccountName, String sUserName, int nStatusId);

    protected abstract void OnChatSendMsgTextSuccess(String sAccountName, String sUserName, String sMsgText, int nUserValue);

    protected abstract void OnChatSendMsgTextFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue);

    protected abstract void OnChatSendMsgTypingSuccess(String sAccountName, String sUserName, int nUserValue);

    protected abstract void OnChatSendMsgTypingFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue);

    protected abstract void OnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact);

    protected abstract void OnChatRecvMsgTypingStart(String sAccountName, String sUserName);

    protected abstract void OnChatRecvMsgTypingStop(String sAccountName, String sUserName);

    protected abstract void OnAudioRecordedPCM(String sAccountName, int nLineNo, byte[] aDataPCM, int nSizePCM, int nTypePCM);

    protected abstract void OnHoldCall(String sAccountName, int nLineNo);

    protected abstract void OnUnHoldCall(String sAccountName, int nLineNo);

    protected abstract void OnVideoRemoteStarted(String sAccountName, int nLineNo);

    protected abstract void OnVideoRemoteEnded(String sAccountName, int nLineNo);

    protected abstract void OnVideoDeviceFrameRGB(int nDeviceId, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight);

    protected abstract void OnVideoRemoteFrameRGB(String sAccountName, int nLineNo, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight);

    protected abstract void OnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId);

    protected abstract void OnNetworkReachability(boolean bAvailable);

    protected abstract void OnAudioDeviceMicVU(int nLevelVU);

    protected abstract void OnAudioDeviceSpkVU(int nLevelVU);

    protected abstract void OnBusyLampSubscribeSuccess(String sAccountName, String sUserName);

    protected abstract void OnBusyLampSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase);

    protected abstract void OnBusyLampContactStatus(String sAccountName, String sUserName, int nStatusId);

    protected abstract void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode);
}

