package com.vaxsoft.vaxphonesip.VaxMainUTIL.BackForeNotify;

import androidx.lifecycle.Lifecycle;
import androidx.lifecycle.LifecycleObserver;
import androidx.lifecycle.OnLifecycleEvent;
import androidx.lifecycle.ProcessLifecycleOwner;

public class VaxBackForeNotify implements LifecycleObserver
{
    IVaxBackForeNotify miBackForeNotify;
    boolean m_bForeground = true;

    public VaxBackForeNotify(IVaxBackForeNotify iBackForeNotify)
    {
        m_bForeground = true;
        miBackForeNotify = iBackForeNotify;
    }

    //////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////

    public void BackForegroundNotify(boolean bEnable)
    {
        m_bForeground = true;

        ProcessLifecycleOwner.get().getLifecycle().removeObserver(this);

        if(bEnable)
            ProcessLifecycleOwner.get().getLifecycle().addObserver(this);
    }

    //////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////

    @OnLifecycleEvent(Lifecycle.Event.ON_START)
    public void onEnterForeground()
    {
        OnApplicationEnterForeground();
    }

    @OnLifecycleEvent(Lifecycle.Event.ON_STOP)
    public void onEnterBackground()
    {
        OnApplicationEnterBackground();
    }

    //////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////

    @OnLifecycleEvent(Lifecycle.Event.ON_RESUME)
    public void appInResumeState()
    {

    }

    @OnLifecycleEvent(Lifecycle.Event.ON_PAUSE)
    public void appInPauseState()
    {

    }

    //////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////

    private void OnApplicationEnterForeground()
    {
        if(m_bForeground == true)
            return;

        m_bForeground = true;

        miBackForeNotify.OnApplicationEnterForeground();
    }

    private void OnApplicationEnterBackground()
    {
        if(m_bForeground == false)
            return;

        m_bForeground = false;

        miBackForeNotify.OnApplicationEnterBackground();
    }
}
