package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll;

import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainNotify.VaxPhoneNotify;
import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.MainTabActivity;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneSIP;

import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.ChatTab.ChatContactRecyclerView;
import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.ChatTab.ChatContactTabFragment;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreChatContact;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreChatMsg;

import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

import java.util.ArrayList;

public class VaxPhoneChat implements IVaxUserAgentSIP
{
    private static VaxPhoneChat mSelf = null;

    private VaxUserAgentSIP mVaxAgentSIP = null;
    private VaxPhoneNotify mVaxPhoneNotify = null;

    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////

    public VaxPhoneChat()
    {
        mSelf = this;

        mVaxAgentSIP = new VaxUserAgentSIP(this);
        mVaxPhoneNotify = new VaxPhoneNotify();
    }

    static public VaxPhoneChat GetSelf()
    {
        return VaxPhoneChat.mSelf;
    }

    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////

    public int GetChatContactCount()
    {
        StoreChatContact objStore = new StoreChatContact();
        return objStore.GetChatContactCount();
    }

    public void LoadChatContactAll()
    {
        StoreChatContact objStore = new StoreChatContact();
        ArrayList aContactDataList = objStore.GetChatContactAll();

        for (int nIndex = 0; nIndex < aContactDataList.size(); nIndex++)
        {
            ArrayList aSubList = (ArrayList) aContactDataList.get(nIndex);

            String sContactName = (String) aSubList.get(1);

            boolean bPresence = Boolean.parseBoolean(String.valueOf(aSubList.get(3)));
            long nMissedCount = Long.valueOf(String.valueOf(aSubList.get(2)));

            mVaxAgentSIP.ChatAddContact(VaxPhoneSIP.ACCOUNT_VAXVOIP, sContactName, bPresence);
            ChatContactRecyclerView.PostChatContactAdded(sContactName, nMissedCount, bPresence);
        }
    }

    public boolean ChatAddContact(String sUserName, boolean bPresence)
    {
        if(!mVaxAgentSIP.ChatAddContact(VaxPhoneSIP.ACCOUNT_VAXVOIP, sUserName, bPresence))
            return false;

        StoreChatContact objStore = new StoreChatContact();
        objStore.AddChatContact(sUserName, 0, bPresence);

        ChatContactTabFragment.PostChatContactAdded();
        ChatContactRecyclerView.PostChatContactAdded(sUserName, 0, bPresence);

        return true;
    }

    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////

    public boolean ChatSubscribeContactAll()
    {
        return mVaxAgentSIP.ChatSubscribeContactAll(VaxPhoneSIP.ACCOUNT_VAXVOIP);
    }

    public boolean ChatSetMyStatus(int nStatusId)
    {
        return mVaxAgentSIP.ChatSetMyStatus(VaxPhoneSIP.ACCOUNT_VAXVOIP, nStatusId);
    }

    public boolean ChatSendMessageText(String sUserName, String sMsgText)
    {
        if(!mVaxAgentSIP.ChatSendMessageText(VaxPhoneSIP.ACCOUNT_VAXVOIP, sUserName, sMsgText, false, 0))
            return false;

        StoreChatMsg objStore = new StoreChatMsg();
        objStore.AddChatMsg(sUserName, sMsgText, true);

        ChatContactRecyclerView.PostChatMessageText(sUserName, mVaxAgentSIP.ChatFindContact(VaxPhoneSIP.ACCOUNT_VAXVOIP, sUserName), sMsgText, true);

        return true;
    }

    public boolean ChatRemoveContact(String sUserName)
    {
        if(!mVaxAgentSIP.ChatRemoveContact(VaxPhoneSIP.ACCOUNT_VAXVOIP, sUserName))
            return false;

        StoreChatContact objContactStore = new StoreChatContact();
        objContactStore.RemoveChatContact(sUserName);

        StoreChatMsg objMsgStore = new StoreChatMsg();
        objMsgStore.ClearContactChatMsgs(sUserName);

        ChatContactTabFragment.PostChatContactDeleted();

        return true;
    }

    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////

    public void OnInitialized()
    {
        ChatContactRecyclerView.PostInitialized();
    }

    public void OnChatContactStatus(String sAccountName, String sUserName, int nStatusId)
    {
        ChatContactRecyclerView.PostChatContactStatus(sUserName, nStatusId);
    }

    public void OnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact)
    {
        if (!bIsChatContact)
            ChatAddContact(sUserName, false);

        StoreChatMsg objStore = new StoreChatMsg();
        objStore.AddChatMsg(sUserName, sMsgText, false);

        if(!MainTabActivity.IsAvailableUI())
            mVaxPhoneNotify.StartMsgNotification(sUserName, sMsgText, MainTabActivity.class);

        ChatContactRecyclerView.PostChatMessageText(sUserName, bIsChatContact, sMsgText, false);
    }
}
