package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll;

import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings.AudioCodecsDialog;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

public class VaxPhoneCodec implements IVaxUserAgentSIP
{
    private static VaxPhoneCodec mSelf = null;
    private VaxUserAgentSIP mVaxAgentSIP = null;

    public VaxPhoneCodec()
    {
        mSelf = this;
        mVaxAgentSIP = new VaxUserAgentSIP(this);
    }

    static public VaxPhoneCodec GetSelf()
    {
        return VaxPhoneCodec.mSelf;
    }

    public boolean ActivateAudioCodec(boolean bEnable, int nCodecNo)
    {
        if(nCodecNo == -1)
        {
            if(bEnable)
                mVaxAgentSIP.SelectAllAudioCodec();
            else
                mVaxAgentSIP.DeselectAllAudioCodec();

            return true;
        }

        if(bEnable)
            return mVaxAgentSIP.SelectAudioCodec(nCodecNo);

        return mVaxAgentSIP.DeselectAudioCodec(nCodecNo);
    }

    public boolean ActivateVideoCodec(boolean bEnable, int nCodecNo)
    {
        if(nCodecNo == -1)
        {
            if(bEnable)
                mVaxAgentSIP.SelectAllVideoCodec();
            else
                mVaxAgentSIP.DeselectAllVideoCodec();

            return true;
        }

        if(bEnable)
            return mVaxAgentSIP.SelectVideoCodec(nCodecNo);

        return mVaxAgentSIP.DeselectVideoCodec(nCodecNo);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public void OnInitialized()
    {
        AudioCodecsDialog.PostInitialize();
    }
}
