package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll;

import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings.SettingsFragment;
import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.CallTab.CallTabFragment;
import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.RecentTab.RecentRecyclerView;

import com.vaxsoft.vaxphonesip.VaxMainUTIL.ProximitySensor.ProximitySensor;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreRecent;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxCallInfo.VaxCallInfo;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

public class VaxPhoneGeneral implements IVaxUserAgentSIP
{
    private static VaxPhoneGeneral mSelf = null;

    private VaxUserAgentSIP mVaxAgentSIP = null;
    private ProximitySensor mProximitySensor = null;

    public VaxPhoneGeneral()
    {
        mSelf = this;

        mVaxAgentSIP = new VaxUserAgentSIP(this);
        mProximitySensor = new ProximitySensor();
    }

    static public VaxPhoneGeneral GetSelf()
    {
        return VaxPhoneGeneral.mSelf;
    }

    ////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////

    public boolean IsLineBusy()
    {
        return mVaxAgentSIP.IsLineBusy(0);
    }

    public boolean IsLineConnected()
    {
        return mVaxAgentSIP.IsLineConnected(0);
    }

    public boolean IsLineHold()
    {
        return mVaxAgentSIP.IsLineHold(0);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public boolean HoldLine()
    {
        return mVaxAgentSIP.HoldLine(0);
    }

    public boolean UnHoldLine()
    {
        return mVaxAgentSIP.UnHoldLine(0);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public boolean IsSpeakerPhone()
    {
        return mVaxAgentSIP.IsSpeakerPhone();
    }

    public boolean SpeakerPhone(boolean bEnable)
    {
        return mVaxAgentSIP.SpeakerPhone(bEnable);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public boolean IsNetworkAvailable()
    {
        return mVaxAgentSIP.IsNetworkAvailable();
    }

    public boolean NetworkReachability(boolean bEnable)
    {
        return mVaxAgentSIP.NetworkReachability(bEnable);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public void OnInitialized()
    {
        SettingsFragment.PostInitialized();
        CallTabFragment.PostInitialized();
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public void OnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo)
    {
        CallTabFragment.PostDialCallStarted();
    }

    public void OnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact)
    {
        CallTabFragment.PostDialCallFailed(nStatusCode, sReasonPhrase);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public void OnConnectedCall(String sAccountName, int nLineNo, String sToRTPIP, int nToRTPPort)
    {
        mProximitySensor.SetProximityMonitoringEnabled(true);
        CallTabFragment.PostConnectedCall();

        //mVaxPhoneNotify.StartCallNotification(MainTabActivity.class, m_sCallerName, m_sCallerId);
    }

    public void OnHungupCall(String sAccountName, int nLineNo)
    {
        mProximitySensor.SetProximityMonitoringEnabled(false);
        CallTabFragment.PostDisconnectedCall();

        //mVaxPhoneNotify.StopCallNotification(true);
    }

    public void OnDisconnectedCall(int nLineNo)
    {
        mProximitySensor.SetProximityMonitoringEnabled(false);
        CallTabFragment.PostDisconnectedCall();
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    public void OnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId)
    {
        StringBuilder sResultName = new StringBuilder();
        StringBuilder sResultPhoneNo = new StringBuilder();
        StringBuilder sResultContactId = new StringBuilder();

        if (bOutboundCallType)
            VaxCallInfo.PrepareCallInfo(sCallerName, sDialNo, sResultName, sResultPhoneNo, sResultContactId);
        else
        {
            VaxCallInfo.PrepareCallInfo(sCallerName, sCallerId, sResultName, sResultPhoneNo, sResultContactId);
        }

        StoreRecent objStore = new StoreRecent();
        int nRecordId = objStore.AddCallHistory(bOutboundCallType, sResultName.toString(), sResultPhoneNo.toString(), nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);

        RecentRecyclerView.PostAddCallHistory(nRecordId, bOutboundCallType, sResultName.toString(), sResultPhoneNo.toString(), nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    public void OnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount)
    {

    }

}
