package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll;

import android.os.Build;
import android.os.Environment;
import android.util.Log;

import com.vaxsoft.vaxphonesip.VaxMainAPP.VaxPhoneAPP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class VaxPhoneLog implements IVaxUserAgentSIP
{
    private static VaxPhoneLog mSelf = null;

    private VaxUserAgentSIP mVaxAgentSIP = null;
    private String m_sLogFile = "";

    public VaxPhoneLog()
    {
        mSelf = this;
        mVaxAgentSIP = new VaxUserAgentSIP(this);
    }

    static public VaxPhoneLog GetSelf()
    {
        return VaxPhoneLog.mSelf;
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    public void DiagnosticLog(boolean bEnable)
    {
        if(!bEnable)
        {
            m_sLogFile = "";
            return;
        }

        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M)
        {
            boolean bCreated = true;

            String sPath = Environment.getExternalStorageDirectory() + "/Android/data/" + VaxPhoneAPP.GetContextAPP().getPackageName();

            File objPkgDirectory = new File(sPath);

            if (!objPkgDirectory.exists())
            {
                bCreated = objPkgDirectory.mkdirs();
            }

            if (bCreated)
            {
                File objFile = new File(sPath, "VaxLog.txt");
                m_sLogFile = objFile.getPath();
            }
            else
            {
                m_sLogFile = "";
            }

            return;
        }

        File AppDir = VaxPhoneAPP.GetContextAPP().getExternalFilesDir(null);
        if (AppDir == null) return;

        File objFile = new File(AppDir, "VaxLog.txt");
        m_sLogFile = objFile.getPath();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    private void WriteToLogFile(String sText)
    {
        if(m_sLogFile.length() == 0)
            return;

        FileWriter objFileWriter;
        try
        {
            objFileWriter = new FileWriter(m_sLogFile, true);
            objFileWriter.write(sText);
            objFileWriter.flush();
            objFileWriter.close();
        }
        catch (IOException e)
        {
            Log.e("Exception", "File write failed: " + e.toString());
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    public void OnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort)
    {
        if(m_sLogFile.equals(""))
            return;

        String sLogPacket = "Received: " + sFromIP + " \n " +  nFromPort + " \n " +  sMsgSIP;

        this.WriteToLogFile(sLogPacket);
    }

    public void OnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort)
    {
        if(m_sLogFile.equals(""))
            return;

        String sLogPacket = "Sent: " + sToIP + " \n " +  nToPort + " \n " +  sMsgSIP;

        this.WriteToLogFile(sLogPacket);
    }
}
