package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll;

import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings.SettingMicSpk;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

public class VaxPhoneMicSpk implements IVaxUserAgentSIP
{
    private static VaxPhoneMicSpk mSelf = null;
    private VaxUserAgentSIP mVaxAgentSIP = null;

    private static boolean m_bMuteMic = false;
    private static boolean m_bMuteSpk = false;

    public VaxPhoneMicSpk()
    {
        mSelf = this;
        mVaxAgentSIP = new VaxUserAgentSIP(this);

        m_bMuteMic = false;
        m_bMuteSpk = false;
    }

    static public VaxPhoneMicSpk GetSelf()
    {
        return VaxPhoneMicSpk.mSelf;
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public boolean AutoGainSpk(boolean bEnable)
    {
        return mVaxAgentSIP.AutoGainSpk(bEnable, 20);
    }

    public boolean AutoGainMic(boolean bEnable)
    {
        return mVaxAgentSIP.AutoGainMic(bEnable,20);
    }

    public boolean SetVolumeBoostMic(boolean bEnable)
    {
        int nBoostVol = 0;

        if(bEnable)
            nBoostVol = 20;

        return mVaxAgentSIP.SetVolumeMic(nBoostVol);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    public static boolean IsMuteMic()
    {
        return VaxPhoneMicSpk.m_bMuteMic;
    }

    public boolean MuteMic(boolean bMute)
    {
        if(!mVaxAgentSIP.MuteMic(bMute))
            return false;

        VaxPhoneMicSpk.m_bMuteMic = bMute;
        return true;
    }

    public static boolean IsMuteSpk()
    {
        return VaxPhoneMicSpk.m_bMuteSpk;
    }

    public boolean MuteSpk(boolean bMute)
    {
        if(!mVaxAgentSIP.MuteSpk(bMute))
            return false;

        VaxPhoneMicSpk.m_bMuteSpk = bMute;
        return true;
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public void OnInitialized()
    {
        SettingMicSpk.PostInitialize();
    }
}
