package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneRing;

import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneRing.VaxRingBusy.VaxRingBusy;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneRing.VaxRingDial.VaxRingDial;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneRing.VaxRingTone.VaxRingTone;

import com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings.StoreRingtones;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

public class VaxPhoneRing implements IVaxUserAgentSIP
{
    private static VaxPhoneRing mSelf = null;
    private VaxUserAgentSIP mVaxAgentSIP = null;

    private VaxRingTone mRingTone = null;

    private String mDialRingFileName = null;
    private String mBusyRingFileName = null;

    public VaxPhoneRing()
    {
        mSelf = this;
        mVaxAgentSIP = new VaxUserAgentSIP(this);

        mRingTone = new VaxRingTone();

        mDialRingFileName = VaxRingDial.GetFileName();
        mBusyRingFileName = VaxRingBusy.GetFileName();
    }

    static public VaxPhoneRing GetSelf()
    {
        return VaxPhoneRing.mSelf;
    }

    ////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////

    public void SetRingtone(int nRingtone)
    {
        mRingTone.SetRingTone(nRingtone);
    }

    public void ActivateRing()
    {
        if(mDialRingFileName.length() != 0)
        {
            mVaxAgentSIP.DialRingEnable(mDialRingFileName);
        }

        if(mBusyRingFileName.length() != 0)
        {
            mVaxAgentSIP.BusyRingEnable(mBusyRingFileName);
        }
    }

    public void MuteRingTone()
    {
        mRingTone.MuteRingTone();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    public void OnInitialized()
    {
        StoreRingtones objStoreRingtones = new StoreRingtones();
        int nToneId = objStoreRingtones.GetRingtone();

        mRingTone.SetRingTone(nToneId);
    }

    public void OnRingToneStarted(String sAccountName)
    {
        mRingTone.StartRingTone();
    }

    public void OnRingToneEnded(String sAccountName)
    {
        mRingTone.StopRingTone();
    }

}
