package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneRing.VaxRingBusy;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import com.vaxsoft.vaxphonesip.VaxMainAPP.VaxPhoneAPP;
import com.vaxsoft.vaxphonesip.R;

public class VaxRingBusy
{
    static public String GetFileName()
    {
        String sFileName = "";

        boolean bCreated = true;

        File objAppDir = VaxPhoneAPP.GetContextAPP().getFilesDir();
        if (objAppDir == null) return "";

        File objRingTonesDir = new File(objAppDir, "RingTones");

        if (!objRingTonesDir.exists())
            bCreated = objRingTonesDir.mkdirs();

        if (bCreated)
        {
            File objFile = new File(objRingTonesDir, "aBusyRing.wav");
            sFileName = objFile.getPath();

            if (objFile.exists())
                return sFileName;

            try
            {
                CopyFileToStorage(sFileName);
            }
            catch (Exception ignored)
            {
                return "";
            }
        }

        return sFileName;
    }

    static private boolean CopyFileToStorage(String sFilePath) throws IOException
    {
        InputStream objReadStream = VaxPhoneAPP.GetContextAPP().getResources().openRawResource(R.raw.busy_ring);
        FileOutputStream objWriteStream = null;

        byte[] aBuffer = new byte[64000];

        try
        {
            objWriteStream = new FileOutputStream(sFilePath);

            while (true)
            {
                int nRead = objReadStream.read(aBuffer);
                if(nRead <= 0) break;

                objWriteStream.write(aBuffer, 0, nRead);
                if(nRead < aBuffer.length) break;
            }
        }
        catch (FileNotFoundException e)
        {
            return false;
        }

        finally
        {
            if (objReadStream != null)
                objReadStream.close();

            if (objWriteStream != null)
                objWriteStream.close();
        }

        return true;
    }
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
