package com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneRing.VaxRingTone;

import android.content.Context;
import android.media.AudioManager;

import com.vaxsoft.vaxphonesip.VaxMainAPP.VaxPhoneAPP;
import com.vaxsoft.vaxphonesip.VaxMainUTIL.AudioPlayer.AudioPlayer;
import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

public class VaxRingTone implements IVaxUserAgentSIP
{
    public static final int VAX_RING_TONE_GROOVY       = 0;
    public static final int VAX_RING_TONE_DIGITAL_RAIN = 1;
    public static final int VAX_RING_TONE_MAGICAL      = 2;
    public static final int VAX_RING_TONE_DEJA_VU      = 3;
    public static final int VAX_RING_TONE_OFFICE_PHONE = 4;

    private VaxUserAgentSIP mVaxAgentSIP = null;
    private AudioPlayer mAudioPlayer = null;

    public VaxRingTone()
    {
        mVaxAgentSIP = new VaxUserAgentSIP(this);
        mAudioPlayer = new AudioPlayer();
    }

    private void LoadRingTone(int nRingId)
    {
        mAudioPlayer.PlayLoad(nRingId);
    }

    public void MuteRingTone()
    {
        StopRingTone();
    }

    public void SetRingTone(int nRingToneId)
    {
        if(nRingToneId == VAX_RING_TONE_GROOVY)
        {
            LoadRingTone(R.raw.ring_tone_groovy);
        }
        else if(nRingToneId == VAX_RING_TONE_DIGITAL_RAIN)
        {
            LoadRingTone(R.raw.ring_tone_digital_rain);
        }
        else if(nRingToneId == VAX_RING_TONE_MAGICAL)
        {
            LoadRingTone(R.raw.ring_tone_magical);
        }
        else if(nRingToneId == VAX_RING_TONE_DEJA_VU)
        {
            LoadRingTone(R.raw.ring_tone_dejavu);
        }
        else if(nRingToneId == VAX_RING_TONE_OFFICE_PHONE)
        {
            LoadRingTone(R.raw.ring_tone_office_phone);
        }
        else
        {
            LoadRingTone(R.raw.ring_tone_digital_rain);
        }
    }

    public void StartRingTone()
    {
        AudioManager objAudioMgr = (AudioManager) VaxPhoneAPP.GetContextAPP().getSystemService(Context.AUDIO_SERVICE);
        objAudioMgr.setMode(AudioManager.MODE_RINGTONE);

        mAudioPlayer.PlayStart(true);
    }

    public void StopRingTone()
    {
        mAudioPlayer.PlayStop();
    }
}
