package com.vaxsoft.vaxphonesip.VaxPhoneUI.AccountLogin;

import android.os.Bundle;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreAccount;

public class AccountInfoFragment extends Fragment
{
    EditText EditTextUserName, EditTextDisplayName, EditTextAuthLogin, EditTextAuthPwd;
    EditText EditTextDomainRealm, EditTextServerAddr, EditTextServerPort;
    CheckBox CheckBoxRegistrationSIP;

    ImageView ToolbarActionIcon;
    TextView ToolbarTitle;

    //////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        return inflater.inflate(R.layout.fragment_account_info, container, false);
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState)
    {
        InitializeViewUI(view);
        InitializeListenerUI();

        SetToolbarUI();
        DisplayAccountInfo();
    }

    private void InitializeViewUI(View view)
    {
        ToolbarTitle =  view.findViewById(R.id.label_screen_name);
        ToolbarActionIcon = view.findViewById(R.id.ToolbarActionIcon);

        EditTextUserName = view.findViewById(R.id.ai_username);
        EditTextDisplayName = view.findViewById(R.id.ai_display_name);
        EditTextAuthLogin = view.findViewById(R.id.ai_auth_login);
        EditTextAuthPwd = view.findViewById(R.id.ai_auth_pwd);
        EditTextDomainRealm = view.findViewById(R.id.ai_domain_realm);
        EditTextServerAddr = view.findViewById(R.id.ai_server_ip);
        EditTextServerPort = view.findViewById(R.id.ai_server_port);

        CheckBoxRegistrationSIP = view.findViewById(R.id.ai_sip_registration);
    }

    private void InitializeListenerUI()
    {
        ToolbarActionIcon.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                OnClickSave();
            }
        });
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    private void SetToolbarUI()
    {
        ToolbarTitle.setText(R.string.title_account_info);

        ToolbarActionIcon.setVisibility(View.VISIBLE);
        ToolbarActionIcon.setImageResource(R.drawable.ic_action_check);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    private void DisplayAccountInfo()
    {
        StoreAccount objStore = new StoreAccount();

        String sUserName = objStore.GetUserName();
        String sDisplayName = objStore.GetDisplayName();
        String sDomainRealm = objStore.GetDomainRealm();

        String sAuthLogin = objStore.GetAuthLogin();
        String sAuthPwd = objStore.GetAuthPwd();

        String sServerAddr = objStore.GetServerAddr();
        String sServerPort = objStore.GetServerPort();

        boolean bRegisterSIP = objStore.GetRegistration();

        if(sUserName.length() == 0)
            sUserName = sAuthLogin;

        if(sDisplayName.length() == 0)
            sDisplayName = sAuthLogin;

        if(sDomainRealm.length() == 0)
            sDomainRealm = sServerAddr;

        EditTextUserName.setText(sUserName);
        EditTextDisplayName.setText(sDisplayName);

        EditTextAuthLogin.setText(sAuthLogin);
        EditTextAuthPwd.setText(sAuthPwd);

        EditTextDomainRealm.setText(sDomainRealm);

        EditTextServerAddr.setText(sServerAddr);
        EditTextServerPort.setText(sServerPort);

        CheckBoxRegistrationSIP.setChecked(bRegisterSIP);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    private void OnClickSave()
    {
        String sUserName = EditTextUserName.getText().toString();
        String sDisplayName = EditTextDisplayName.getText().toString();

        String sAuthLogin = EditTextAuthLogin.getText().toString();
        String sAuthPwd = EditTextAuthPwd.getText().toString();

        String sDomainRealm = EditTextDomainRealm.getText().toString();

        String sServerAddr = EditTextServerAddr.getText().toString();
        String sServerPort = EditTextServerPort.getText().toString();

        boolean bRegisterSIP = CheckBoxRegistrationSIP.isChecked();

        /////////////////////////////////////////////////////////////////////////////////

        StoreAccount objStore = new StoreAccount();

        objStore.SetUserName(sUserName);
        objStore.SetDisplayName(sDisplayName);

        objStore.SetAuthLogin(sAuthLogin);
        objStore.SetAuthPwd(sAuthPwd);

        objStore.SetDomainRealm(sDomainRealm);

        objStore.SetServerAddr(sServerAddr);
        objStore.SetServerPort(sServerPort);

        objStore.SetRegistration(bRegisterSIP);

        /////////////////////////////////////////////////////////////////////////////////

        ((AccountLoginActivity) getActivity()).DisplayAccountInfo();

        getActivity().onBackPressed();
    }
}
