package com.vaxsoft.vaxphonesip.VaxPhoneUI.IncomingCall;

import android.content.Intent;
import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;
import androidx.appcompat.widget.AppCompatButton;
import android.view.View;
import android.view.WindowManager;
import android.widget.TextView;

import com.vaxsoft.vaxphonesip.VaxMainAPP.VaxPhoneAPP;
import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.MainTabActivity;
import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneRing.VaxPhoneRing;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentSIP;

public class IncomingCallActivity extends AppCompatActivity implements View.OnClickListener
{
    private static IncomingCallActivity self = null;

    private AppCompatButton BtnAcceptCall, BtnRejectCall, BtnMuteRing;
    private TextView TextViewCallerName, TextViewCallerId;

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_incoming_call);

        getWindow().addFlags(WindowManager.LayoutParams.FLAG_DISMISS_KEYGUARD | WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED | WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON);

        InitializeViewUI();
        InitializeListenerUI();
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    static public void ShowIncomingUI(String sCallerName, String sCallerId)
    {
        if(IncomingCallActivity.self != null)
            return;

        Intent objIntent = new Intent(VaxPhoneAPP.GetContextAPP(), IncomingCallActivity.class);
        objIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

        objIntent.putExtra("CallerName", sCallerName);
        objIntent.putExtra("CallerId", sCallerId);

        VaxPhoneAPP.GetContextAPP().startActivity(objIntent);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    static public void HideIncomingUI()
    {
        if(IncomingCallActivity.self == null)
            return;

        IncomingCallActivity.self.finish();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    private void InitializeViewUI()
    {
        BtnAcceptCall = findViewById(R.id.accept_call);
        BtnRejectCall = findViewById(R.id.reject_call);
        BtnMuteRing = findViewById(R.id.mute_ring);

        TextViewCallerName = findViewById(R.id.caller_name);
        TextViewCallerId = findViewById(R.id.caller_id);

        Intent objIntent = getIntent();

        if (objIntent != null)
        {
            String sCallerName = objIntent.getStringExtra("CallerName");
            String sCallerId = objIntent.getStringExtra("CallerId");

            TextViewCallerName.setText(sCallerName);
            TextViewCallerId.setText(sCallerId);
        }
    }

    private void InitializeListenerUI()
    {
        BtnAcceptCall.setOnClickListener(this);
        BtnRejectCall.setOnClickListener(this);
        BtnMuteRing.setOnClickListener(this);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void onClick(View view)
    {
        int nId = view.getId();

        if(nId == R.id.accept_call)
        {
            OnClickAcceptCall();
        }
        else if(nId == R.id.reject_call)
        {
            OnClickRejectCall();
        }
        else if(nId == R.id.mute_ring)
        {
            OnClickMuteRing();
        }
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    private void OnClickAcceptCall()
    {
        VaxUserAgentSIP objVaxAgentSIP = new VaxUserAgentSIP(null);
        objVaxAgentSIP.AcceptCall(0);

        startActivity(new Intent(this, MainTabActivity.class));

        finish();
    }

    private void OnClickRejectCall()
    {
        VaxUserAgentSIP objVaxAgentSIP = new VaxUserAgentSIP(null);
        objVaxAgentSIP.RejectCall();

        finish();
    }

    private void OnClickMuteRing()
    {
        VaxPhoneRing.GetSelf().MuteRingTone();
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    @Override
    protected void onResume()
    {
        self = this;
        super.onResume();
    }

    @Override
    protected void onDestroy()
    {
        self = null;
        super.onDestroy();

        getWindow().clearFlags(WindowManager.LayoutParams.FLAG_DISMISS_KEYGUARD | WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED | WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON);
    }
}
