package com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.fragment.app.DialogFragment;

import VaxVoIP.VaxUserAgentLib.VaxUserAgentLib;
import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneDTMF.VaxPhoneDTMF;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings.StoreDigitDTMF;

public class DigitDTMFDialog extends DialogFragment
{
    final CharSequence[] mTypeNameDTMF = {"Auto", "Outband (RFC2833)", "SIP INFO", "Inband (Audio Based)"};
    int m_nSelectedTypeDTMF = VaxUserAgentLib.VAX_DTMF_TYPE_AUTO;

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState)
    {
        AlertDialog.Builder objBuilder = new AlertDialog.Builder(getActivity(), R.style.DialogTheme);
        objBuilder.setTitle(R.string.choose_digit_dtmf);

        objBuilder.setSingleChoiceItems(mTypeNameDTMF, GetSelectedItem(), new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int nSelectedTypeDTMF)
            {
                m_nSelectedTypeDTMF = nSelectedTypeDTMF;
            }
        }).setPositiveButton("Ok", new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                OnClickOkButton();
            }
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                dialog.dismiss();
            }
        });

        return objBuilder.create();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    private void OnClickOkButton()
    {
        VaxPhoneDTMF.GetSelf().ForceDigitDTMF(m_nSelectedTypeDTMF, true);

        StoreDigitDTMF objStore = new StoreDigitDTMF();
        objStore.SetDigitDTMF(m_nSelectedTypeDTMF);
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    private int GetSelectedItem()
    {
        StoreDigitDTMF objStore = new StoreDigitDTMF();
        m_nSelectedTypeDTMF = objStore.GetDigitDTMF();

        return m_nSelectedTypeDTMF;
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////
}