package com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings;

import android.os.Bundle;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;

import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.MainTabActivity;
import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings.StoreNetwork;

public class NetworkFragment extends Fragment implements ViewGroup.OnFocusChangeListener, CompoundButton.OnCheckedChangeListener
{
    EditText LocalPortSIP;
    CheckBox ChooseRandomlySIP;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        return inflater.inflate(R.layout.fragment_network, container, false);
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState)
    {
        Toolbar toolbar = view.findViewById(R.id.actionbar);
        ((MainTabActivity) getActivity()).setSupportActionBar(toolbar);
        ActionBar actionBar = ((MainTabActivity) getActivity()).getSupportActionBar();

        if (actionBar != null)
        {
            actionBar.setTitle("Network");
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        InitViews(view);
        InitClickListners();
        UpdateUI();
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    private void InitViews(View view)
    {
        LocalPortSIP = view.findViewById(R.id.edit_text_local_port_sip);
        ChooseRandomlySIP = view.findViewById(R.id.checkbox_choose_randomly_sip);
    }

    private void InitClickListners()
    {
        LocalPortSIP.setOnFocusChangeListener(this);
        ChooseRandomlySIP.setOnCheckedChangeListener(this);
    }

    private void UpdateUI()
    {
        StoreNetwork objStoreNetwork = new StoreNetwork();

        String sLocalPortSIP = String.valueOf(objStoreNetwork.GetLocalPortSIP());
        LocalPortSIP.setText(sLocalPortSIP);

        boolean bChooseRandomlySIP = objStoreNetwork.IsChooseRandomlySIP();
        ChooseRandomlySIP.setChecked(bChooseRandomlySIP);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void onFocusChange(View view, boolean Focus)
    {
        if(view.getId() == R.id.edit_text_local_port_sip)
        {
            if (!Focus)
                onFocusChangeLocalPortSIP();
        }
    }

    @Override
    public void onCheckedChanged(CompoundButton compoundButton, boolean isChecked)
    {
        int nId = compoundButton.getId();

        if(nId == R.id.checkbox_choose_randomly_sip)
        {
            onCheckedChangedChooseRandomlySIP(isChecked);
        }
    }

    ////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////

    private void onFocusChangeLocalPortSIP()
    {
        String sLocalPortSIP = LocalPortSIP.getText().toString().trim();

        if(sLocalPortSIP.length() == 0)
            return;

        int nLocalPortSIP = Integer.parseInt(sLocalPortSIP);

        StoreNetwork objStoreNetwork = new StoreNetwork();
        objStoreNetwork.SetLocalPortSIP(nLocalPortSIP);
    }

    private void onCheckedChangedChooseRandomlySIP(boolean isChecked)
    {
        StoreNetwork objStoreNetwork = new StoreNetwork();
        objStoreNetwork.SetChooseRandomlySIP(isChecked);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    public static int GetNetworkPortSIP()
    {
        StoreNetwork objStore = new StoreNetwork();
        return objStore.GetLocalPortSIP();
    }

    public static boolean IsRandomPortSIP()
    {
        StoreNetwork objStore = new StoreNetwork();
        return objStore.IsChooseRandomlySIP();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////
}
