package com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings;

import android.os.Bundle;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.CompoundButton;

import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxPhoneUI.MainTab.MainTabActivity;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneMicSpk;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings.StoreSpkMic;

public class SettingMicSpk extends Fragment implements CompoundButton.OnCheckedChangeListener
{
    CheckBox AutoGainSpk, AutoGainMic, VolumeBoostMic;
    boolean m_bAutoGainSpk , m_bAutoGainMic, m_bVolumeBoostMic = false;

    ////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        return inflater.inflate(R.layout.fragment_spk_mic, container, false);
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState)
    {
        Toolbar toolbar = view.findViewById(R.id.actionbar);
        ((MainTabActivity) getActivity()).setSupportActionBar(toolbar);
        ActionBar actionBar = ((MainTabActivity) getActivity()).getSupportActionBar();

        if (actionBar != null)
        {
            actionBar.setTitle("Speaker & Microphone");
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        InitView(view);
        InitCheckChangedListeners();
        UpdateUI();
    }

    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////

    private void InitView(View view)
    {
        AutoGainSpk = view.findViewById(R.id.checkbox_auto_gain_spk);

        AutoGainMic = view.findViewById(R.id.checkbox_auto_gain_mic);
        VolumeBoostMic = view.findViewById(R.id.checkbox_volume_boost_mic);
    }

    private void InitCheckChangedListeners()
    {
        AutoGainSpk.setOnCheckedChangeListener(this);

        AutoGainMic.setOnCheckedChangeListener(this);
        VolumeBoostMic.setOnCheckedChangeListener(this);
    }

    private void UpdateUI()
    {
        StoreSpkMic objStoreSpkMic = new StoreSpkMic();

        m_bAutoGainSpk = objStoreSpkMic.GetAutoGainSpk();
        AutoGainSpk.setChecked(m_bAutoGainSpk);

        m_bAutoGainMic = objStoreSpkMic.GetAutoGainMic();
        AutoGainMic.setChecked(m_bAutoGainMic);

        m_bVolumeBoostMic = objStoreSpkMic.GetVolumeBoostMic();
        VolumeBoostMic.setChecked(m_bVolumeBoostMic);
    }

    ////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked)
    {
        int nId = compoundButton.getId();

        if(nId == R.id.checkbox_auto_gain_spk)
        {
            OnClickAutoGainSpk(bChecked);
        }
        else if(nId == R.id.checkbox_auto_gain_mic)
        {
            OnClickAutoGainMic(bChecked);
        }
        else if(nId == R.id.checkbox_volume_boost_mic)
        {
            OnClickVolBoostMic(bChecked);
        }
    }

    ////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////

    private void OnClickAutoGainSpk(boolean bChecked)
    {
        VaxPhoneMicSpk.GetSelf().AutoGainSpk(bChecked);

        StoreSpkMic objStoreSpkMic = new StoreSpkMic();
        objStoreSpkMic.SetAutoGainSpk(bChecked);
    }

    private void OnClickAutoGainMic(boolean bChecked)
    {
        VaxPhoneMicSpk.GetSelf().AutoGainMic(bChecked);

        StoreSpkMic objStoreSpkMic = new StoreSpkMic();
        objStoreSpkMic.SetAutoGainMic(bChecked);
    }

    private void OnClickVolBoostMic(boolean bChecked)
    {
        VaxPhoneMicSpk.GetSelf().SetVolumeBoostMic(bChecked);

        StoreSpkMic objStoreSpkMic = new StoreSpkMic();
        objStoreSpkMic.SetVolumeBoostMic(bChecked);
    }

    ////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////

    public static void PostInitialize()
    {
        StoreSpkMic objStoreSpkMic = new StoreSpkMic();

        boolean bEnable = objStoreSpkMic.GetAutoGainSpk();
        VaxPhoneMicSpk.GetSelf().AutoGainSpk(bEnable);

        bEnable = objStoreSpkMic.GetAutoGainMic();
        VaxPhoneMicSpk.GetSelf().AutoGainMic(bEnable);

        bEnable = objStoreSpkMic.GetVolumeBoostMic();
        VaxPhoneMicSpk.GetSelf().SetVolumeBoostMic(bEnable);
    }
}
