package com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.fragment.app.DialogFragment;

import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneVideo;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings.StoreVideoBitrate;

public class VideoBitrateDialog extends DialogFragment
{
    final CharSequence[] VideoBitrateDialogOptions = {"Low", "Normal", "Medium", "High", "Maximum"};
    int m_nSelectedItem = -1;

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState)
    {
        AlertDialog.Builder objBuilder = new AlertDialog.Builder(getActivity(), R.style.DialogTheme);

        objBuilder.setTitle(R.string.choose_video_bitrate);
        objBuilder.setSingleChoiceItems(VideoBitrateDialogOptions, GetSelectedItem(), new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                m_nSelectedItem = which;
            }
        }).setPositiveButton("Ok", new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                StoreVideoBitrate objStoreBitrate = new StoreVideoBitrate();
                objStoreBitrate.SetVideoBitrate(m_nSelectedItem);

                VaxPhoneVideo.GetSelf().ApplyVideoBitrate(m_nSelectedItem);
            }
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                dialog.dismiss();
            }
        });

        return objBuilder.create();
    }

    private int GetSelectedItem()
    {
        m_nSelectedItem =  new StoreVideoBitrate().GetVideoBitrate();

        return m_nSelectedItem;
    }

    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////

    public static void PostInitialized()
    {
        StoreVideoBitrate objStoreBitrate = new StoreVideoBitrate();
        int nQualityBitrate = objStoreBitrate.GetVideoBitrate();

        VaxPhoneVideo.GetSelf().ApplyVideoBitrate(nQualityBitrate);
    }
}