package com.vaxsoft.vaxphonesip.VaxPhoneUI.MainDrawer.MainDrawerSettings;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.fragment.app.DialogFragment;

import VaxVoIP.VaxUserAgentLib.VaxUserAgentLib;
import com.vaxsoft.vaxphonesip.R;
import com.vaxsoft.vaxphonesip.VaxPhoneSIP.VaxPhoneAll.VaxPhoneCodec;
import com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings.StoreVideoCodecs;

public class VideoCodecsDialog extends DialogFragment
{
    final CharSequence[] aVideoCodec = {"VP8"};
    boolean[] m_aVideoCodecs = null;

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState)
    {
        VideoCodecsDialog.ApplyVideoCodec();

        AlertDialog.Builder objBuilder = new AlertDialog.Builder(getActivity(), R.style.DialogTheme);

        objBuilder.setTitle(R.string.choose_video_codecs);

        objBuilder.setMultiChoiceItems(aVideoCodec, GetCheckedItem() , new DialogInterface.OnMultiChoiceClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int SelectedIndex, boolean isChecked)
            {
                OnClickCheckBox(SelectedIndex, isChecked);
            }
        }).setPositiveButton("Ok", new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                OnClickOKButton();

            }
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener()
        {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                dialog.dismiss();
            }
        });

        return objBuilder.create();
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    private void OnClickCheckBox(int nSelectedCodec, boolean bChecked)
    {
        if (m_aVideoCodecs == null)
            m_aVideoCodecs = GetCheckedItem();

        if (nSelectedCodec == VaxUserAgentLib.VAX_VIDEO_CODEC_VP8)
            m_aVideoCodecs[VaxUserAgentLib.VAX_VIDEO_CODEC_VP8] = bChecked;
    }

    private void OnClickOKButton()
    {
        if (m_aVideoCodecs == null)
            m_aVideoCodecs = GetCheckedItem();

        StoreVideoCodecs objStoreCodecs = new StoreVideoCodecs();
        objStoreCodecs.SetVideoCodecs(m_aVideoCodecs);

        for(int nCount = 0; nCount < VaxUserAgentLib.VAX_VIDEO_CODEC_TOTAL; nCount++)
        {
            int nCodecNo = nCount;
            boolean bEnabled = m_aVideoCodecs[nCount];

            VaxPhoneCodec.GetSelf().ActivateVideoCodec(bEnabled, nCodecNo);
        }
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    private boolean[] GetCheckedItem()
    {
        boolean[] aVideoCodecs = new boolean[VaxUserAgentLib.VAX_VIDEO_CODEC_TOTAL];

        StoreVideoCodecs objStoreCodecs = new StoreVideoCodecs();
        objStoreCodecs.GetVideoCodecs(aVideoCodecs);

        m_aVideoCodecs = aVideoCodecs;

        return aVideoCodecs;
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    public static void PostInitialize()
    {
        VideoCodecsDialog.ApplyVideoCodec();
    }

    public static void ApplyVideoCodec()
    {
        boolean[] aVideoCodecs = new boolean[VaxUserAgentLib.VAX_VIDEO_CODEC_TOTAL];

        StoreVideoCodecs objStoreCodecs = new StoreVideoCodecs();
        objStoreCodecs.GetVideoCodecs(aVideoCodecs);

        VaxPhoneCodec.GetSelf().ActivateVideoCodec(false, -1);

        for(int nCount = 0; nCount < VaxUserAgentLib.VAX_VIDEO_CODEC_TOTAL; nCount++)
        {
            int nCodecNo = nCount;
            boolean bEnabled = aVideoCodecs[nCount];

            VaxPhoneCodec.GetSelf().ActivateVideoCodec(bEnabled, nCodecNo);
        }
    }
}