package com.vaxsoft.vaxphonesip.VaxStoreData;

import com.vaxsoft.vaxphonesip.VaxStoreData.DataPRF.DataPreference;

public class StoreAccount
{
    static private final String ACCOUNT_USER_NAME = "VaxStoreLoginInfo_Username";
    static private final String ACCOUNT_DISPLAY_NAME = "VaxStoreLoginInfo_DisplayName";

    static private final String ACCOUNT_AUTH_LOGIN = "VaxStoreLoginInfo_AuthLogin";
    static private final String ACCOUNT_AUTH_PWD = "VaxStoreLoginInfo_Password";

    static private final String ACCOUNT_DOMAIN_REALM = "VaxStoreLoginInfo_DomainRealm";

    static private final String ACCOUNT_SERVER_ADDR = "VaxStoreLoginInfo_Server_IP";
    static private final String ACCOUNT_SERVER_PORT = "VaxStoreLoginInfo_Server_Port";

    static private final String ACCOUNT_REGISTRATION = "VaxStoreLoginInfo_Registration_SIP";
    static private final String ACCOUNT_STATUS_ONLINE = "VaxStoreLoginInfo_Online_Status";

    static private String ACCOUNT_USER_NAME_DEFAULT = "";
    static private String ACCOUNT_DISPLAY_NAME_DEFAULT = "";

    static private String ACCOUNT_AUTH_LOGIN_DEFAULT = "";
    static private String ACCOUNT_AUTH_PWD_DEFAULT = "";

    static private String ACCOUNT_DOMAIN_REALM_DEFAULT = "";

    static private String ACCOUNT_SERVER_ADDR_DEFAULT = "";
    static private String ACCOUNT_SERVER_PORT_DEFAULT = "5060";

    static private boolean ACCOUNT_REGISTRATION_DEFAULT = true;
    static private boolean ACCOUNT_STATUS_ONLINE_DEFAULT = false;

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetUserName(String sName)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_USER_NAME, sName);
    }

    public String GetUserName()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_USER_NAME, ACCOUNT_USER_NAME_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetDisplayName(String sName)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_DISPLAY_NAME, sName);
    }

    public String GetDisplayName()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_DISPLAY_NAME, ACCOUNT_DISPLAY_NAME_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetAuthLogin(String sLogin)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_AUTH_LOGIN, sLogin);
    }

    public String GetAuthLogin()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_AUTH_LOGIN, ACCOUNT_AUTH_LOGIN_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetAuthPwd(String sPwd)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_AUTH_PWD, sPwd);
    }

    public String GetAuthPwd()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_AUTH_PWD, ACCOUNT_AUTH_PWD_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetDomainRealm(String sDomain)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_DOMAIN_REALM, sDomain);
    }

    public String GetDomainRealm()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_DOMAIN_REALM, ACCOUNT_DOMAIN_REALM_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetServerAddr(String sAddr)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_SERVER_ADDR, sAddr);
    }

    public String GetServerAddr()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_SERVER_ADDR, ACCOUNT_SERVER_ADDR_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetServerPort(String sPort)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_SERVER_PORT, sPort);
    }

    public String GetServerPort()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_SERVER_PORT, ACCOUNT_SERVER_PORT_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    public void SetRegistration(boolean bEnable)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_REGISTRATION, bEnable);
    }

    public boolean GetRegistration()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_REGISTRATION, ACCOUNT_REGISTRATION_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////

    static public void SetAccountStatusOnline(boolean bOnline)
    {
        DataPreference.WritePreferenceValue(ACCOUNT_STATUS_ONLINE, bOnline);
    }

    static public boolean IsAccountStatusOnline()
    {
        return DataPreference.ReadPreferenceValue(ACCOUNT_STATUS_ONLINE, ACCOUNT_STATUS_ONLINE_DEFAULT);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////
}
