package com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings;

import VaxVoIP.VaxUserAgentLib.VaxUserAgentLib;
import com.vaxsoft.vaxphonesip.VaxStoreData.DataPRF.DataPreference;

public class StoreAudioCodecs
{
    private final String AUDIO_CODEC_G711uLAW = "VaxAudioCodecG711uLaw";
    private final String AUDIO_CODEC_G711aLAW = "VaxAudioCodecG711aLaw";
    private final String AUDIO_CODEC_G729 = "VaxAudioCodecG729";
    private final String AUDIO_CODEC_GSM = "VaxAudioCodecGSM";
    private final String AUDIO_CODEC_iLBC = "VaxAudioCodeciLBC";

    private final boolean AUDIO_CODEC_G711uLAW_DEFAULT_VALUE = true;
    private final boolean AUDIO_CODEC_G711aLAW_DEFAULT_VALUE = true;
    private final boolean AUDIO_CODEC_G729_DEFAULT_VALUE = true;
    private final boolean AUDIO_CODEC_GSM_DEFAULT_VALUE = true;
    private final boolean AUDIO_CODEC_iLBC_DEFAULT_VALUE = true;

    ////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////

    public void GetAudioCodecs(boolean[] AudioCodecs)
    {
        AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_G711U] = DataPreference.ReadPreferenceValue(AUDIO_CODEC_G711uLAW, AUDIO_CODEC_G711uLAW_DEFAULT_VALUE);
        AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_G711A] = DataPreference.ReadPreferenceValue(AUDIO_CODEC_G711aLAW, AUDIO_CODEC_G711aLAW_DEFAULT_VALUE);
        AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_GSM610] = DataPreference.ReadPreferenceValue(AUDIO_CODEC_GSM, AUDIO_CODEC_GSM_DEFAULT_VALUE);
        AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_ILBC] = DataPreference.ReadPreferenceValue(AUDIO_CODEC_iLBC, AUDIO_CODEC_iLBC_DEFAULT_VALUE);
        AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_G729] = DataPreference.ReadPreferenceValue(AUDIO_CODEC_G729, AUDIO_CODEC_G729_DEFAULT_VALUE);
    }

    public void SetAudioCodecs(boolean[] AudioCodecs)
    {
        DataPreference.WritePreferenceValue(AUDIO_CODEC_G711uLAW, AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_G711U]);
        DataPreference.WritePreferenceValue(AUDIO_CODEC_G711aLAW, AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_G711A]);
        DataPreference.WritePreferenceValue(AUDIO_CODEC_GSM, AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_GSM610]);
        DataPreference.WritePreferenceValue(AUDIO_CODEC_iLBC, AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_ILBC]);
        DataPreference.WritePreferenceValue(AUDIO_CODEC_G729, AudioCodecs[VaxUserAgentLib.VAX_AUDIO_CODEC_G729]);
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////
}
