package com.vaxsoft.vaxphonesip.VaxStoreData.StoreSettings;

import com.vaxsoft.vaxphonesip.VaxStoreData.DataPRF.DataPreference;

public class StoreSpkMic
{
    private final String AUTO_GAIN_SPK = "VaxAutoGainSpk";
    private final String AUTO_GAIN_MIC = "VaxAutoGainMic";
    private final String VOLUME_BOOST_MIC = "VaxVolumeBoostMic";

    private boolean AUTO_GAIN_SPK_DEFAULT_VALUE = false;
    private boolean AUTO_GAIN_MIC_DEFAULT_VALUE = false;
    private boolean VOLUME_BOOST_MIC_DEFAULT_VALUE = false;

    //////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////

    public boolean GetAutoGainSpk()
    {
        return DataPreference.ReadPreferenceValue(AUTO_GAIN_SPK, AUTO_GAIN_SPK_DEFAULT_VALUE);
    }

    public boolean GetAutoGainMic()
    {
        return DataPreference.ReadPreferenceValue(AUTO_GAIN_MIC, AUTO_GAIN_MIC_DEFAULT_VALUE);
    }

    public boolean GetVolumeBoostMic()
    {
        return DataPreference.ReadPreferenceValue(VOLUME_BOOST_MIC, VOLUME_BOOST_MIC_DEFAULT_VALUE);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////

    public void SetAutoGainSpk(boolean bRandomlySIP)
    {
        DataPreference.WritePreferenceValue(AUTO_GAIN_SPK, bRandomlySIP);
    }

    public void SetAutoGainMic(boolean bRandomlySIP)
    {
        DataPreference.WritePreferenceValue(AUTO_GAIN_MIC, bRandomlySIP);
    }

    public void SetVolumeBoostMic(boolean bRandomlySIP)
    {
        DataPreference.WritePreferenceValue(VOLUME_BOOST_MIC, bRandomlySIP);
    }
}
