package com.vaxsoft.vaxphonesip.VaxUserAgentSIP;

public interface IVaxUserAgentSIP
{
    default void OnInitialized(){}
    default void OnUnInitialized(){}

    default void OnConnectingToRegister(String sAccountName){}
    default void OnTryingToRegister(String sAccountName){}

    default void OnFailToRegister(String sAccountName, int nStatusCode, String sReasonPhrase){}
    default void OnSuccessToRegister(String sAccountName){}

    default void OnConnectingToReRegister(String sAccountName){}
    default void OnTryingToReRegister(String sAccountName){}

    default void OnFailToReRegister(String sAccountName, int nStatusCode, String sReasonPhrase){}
    default void OnSuccessToReRegister(String sAccountName){}

    default void OnTryingToUnRegister(String sAccountName){}
    default void OnFailToUnRegister(String sAccountName){}
    default void OnSuccessToUnRegister(String sAccountName){}

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    default void OnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo){}
    default void OnDialingCall(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase){}
    default void OnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact){}

    default void OnConnectedCall(String sAccountName, int nLineNo, String sToAddrRTP, int nToPortRTP){}
    default void OnHungupCall(String sAccountName, int nLineNo){}
    default void OnDisconnectedCall(int nLineNo){}

    default void OnIncomingCallStarted(String sAccountName, String sCallerName, String sCallerId){}
    default void OnIncomingCallEnded(String sAccountName, int nReasonCode){}

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    default void OnTransferCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase){}
    default void OnTransferCallAccepted(String sAccountName, int nLineNo){}

    default void OnPlayWaveDone(String sAccountName, int nLineNo){}
    default void OnDigitDTMF(String sAccountName, int nLineNo, String sDigit){}

    default void OnMsgNOTIFY(String sAccountName, String sMsg){}
    default void OnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount){}

    default void OnRingToneStarted(String sAccountName){}
    default void OnRingToneEnded(String sAccountName){}

    default void OnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort){}
    default void OnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort){}

    default void OnAudioSessionLost(String sAccountName, int nLineNo){}

    default void OnSuccessToHold(String sAccountName, int nLineNo){}
    default void OnTryingToHold(String sAccountName, int nLineNo){}
    default void OnFailToHold(String sAccountName, int nLineNo){}

    default void OnSuccessToUnHold(String sAccountName, int nLineNo){}
    default void OnTryingToUnHold(String sAccountName, int nLineNo){}
    default void OnFailToUnHold(String sAccountName, int nLineNo){}

    default void OnTryingToRefresh(String sAccountName, int nLineNo){}
    default void OnFailToRefresh(String sAccountName, int nLineNo){}
    default void OnSuccessToRefresh(String sAccountName, int nLineNo){}

    default void OnChatSubscribeSuccess(String sAccountName, String sUserName){}
    default void OnChatSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase){}

    default void OnChatContactStatus(String sAccountName, String sUserName, int nStatusId){}

    default void OnChatSendMsgTextSuccess(String sAccountName, String sUserName, String sMsgText, int nUserValue){}
    default void OnChatSendMsgTextFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue){}

    default void OnChatSendMsgTypingSuccess(String sAccountName, String sUserName, int nUserValue){}
    default void OnChatSendMsgTypingFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue){}

    default void OnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact){}
    default void OnChatRecvMsgTypingStart(String sAccountName, String sUserName){}
    default void OnChatRecvMsgTypingStop(String sAccountName, String sUserName){}

    default void OnAudioRecordedPCM(String sAccountName, int nLineNo, byte[] aDataPCM, int nSizePCM, int nTypePCM){}

    default void OnHoldCall(String sAccountName, int nLineNo){}
    default void OnUnHoldCall(String sAccountName, int nLineNo){}

    default void OnVideoRemoteStarted(String sAccountName, int nLineNo){}
    default void OnVideoRemoteEnded(String sAccountName, int nLineNo){}

    default void OnVideoDeviceFrameRGB(int nDeviceId, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight){}
    default void OnVideoRemoteFrameRGB(String sAccountName, int nLineNo, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight){}

    default void OnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId){}
    default void OnNetworkReachability(boolean bAvailable){}

    default void OnAudioDeviceMicVU(int nLevelVU){}
    default void OnAudioDeviceSpkVU(int nLevelVU){}

    default void OnBusyLampSubscribeSuccess(String sAccountName, String sUserName){}
    default void OnBusyLampSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase){}
    default void OnBusyLampContactStatus(String sAccountName, String sUserName, int nStatusId){}

    default void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode){}

    default void OnVaxRegisterTryingPushKit(){}
    default void OnVaxRegisterFailedPushKit(){}
    default void OnVaxRegisterSuccessPushKit(String sDeviceToken){}
    default void OnVaxRegisterNewTokenPushKit(String sDeviceToken){}

    default void OnIncomingCallPushKit(String sCallerName, String sCallerId){}
    
}
