package com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxPushKit;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.messaging.FirebaseMessaging;

import androidx.annotation.NonNull;

import java.util.Map;

public class VaxPushKit
{
    /////////////////////////////////////////////////////////////////////////////////////

    static private VaxPushKit mSelf;

    private IVaxPushKit mIVaxPushKit = null;

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public VaxPushKit(IVaxPushKit iVaxPushKit)
    {
        VaxPushKit.mSelf = this;
        mIVaxPushKit = iVaxPushKit;
    }

    public boolean Start()
    {
        try
        {
            FirebaseMessaging.getInstance().getToken().addOnCompleteListener(new OnCompleteListener<String>()
            {
                @Override
                public void onComplete(@NonNull Task<String> task)
                {
                    if(task.isComplete())
                    {
                        String sToken = task.getResult();

                        //Log.e("VaxPhoneSIP", sToken);

                        OnVaxSuccessPushKit(sToken);
                    }
                    else
                    {
                        OnVaxFailedPushKit();
                    }
                }
            });
        }
        catch (Exception exception)
        {
            return false;
        }

        OnVaxTryingPushKit();
        return true;
    }

    private void OnVaxTryingPushKit()
    {
        mIVaxPushKit.OnVaxTryingPushKit();
    }

    private void OnVaxSuccessPushKit(String sDeviceToken)
    {
        mIVaxPushKit.OnVaxSuccessPushKit(sDeviceToken);
    }

    private void OnVaxNewTokenPushKit(String sDeviceToken)
    {
        mIVaxPushKit.OnVaxNewTokenPushKit(sDeviceToken);
    }

    private void OnVaxFailedPushKit()
    {
        mIVaxPushKit.OnVaxFailedPushKit();
    }

    private void OnVaxNotificationPushKit(String sCallerName, String sCallerId)
    {
        mIVaxPushKit.OnVaxNotificationPushKit(sCallerName, sCallerId);
    }

    ///////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////

    static public void PostVaxNewTokenPushKit(String sDeviceToken)
    {
        if(VaxPushKit.mSelf == null)
            return;

        VaxPushKit.mSelf.OnVaxNewTokenPushKit(sDeviceToken);
    }

    static public void PostVaxNotificationPushKit(Map<String, String> objData)
    {
        if(VaxPushKit.mSelf == null)
            return;

        String sCallerName = "";
        String sCallerId = "";

        if (objData.size() > 0)
        {
            sCallerName = objData.get("CallerName");
            sCallerId = objData.get("CallerId");
        }

        VaxPushKit.mSelf.OnVaxNotificationPushKit(sCallerName, sCallerId);
    }

}
