package com.vaxsoft.vaxphonesip.VaxUserAgentSIP;

import android.content.Context;

import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxAudioDevice.VaxAudioDevice;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxPushKit.IVaxPushKit;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxPushKit.VaxPushKit;

import VaxVoIP.VaxUserAgentLib.VaxUserAgentLib;

public class VaxUserAgentLibSIP extends VaxUserAgentLib implements IVaxPushKit
{
    private VaxPushKit mPushKit = null;
    private VaxAudioDevice mAudioDevice = null;

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public VaxUserAgentLibSIP(Context objContext)
    {
        super(objContext);

        mPushKit = new VaxPushKit(this);
        mAudioDevice = new VaxAudioDevice(objContext);
    }


    public boolean RegisterAccountPushKit(String sAccountName, int nExpire)
    {
        mPushKit.Start();
        return true;
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public void OnVaxTryingPushKit()
    {
        VaxUserAgentSIP.OnVaxRegisterTryingPushKit();
    }

    public void OnVaxSuccessPushKit(String sDeviceToken)
    {
        VaxUserAgentSIP.OnVaxRegisterSuccessPushKit(sDeviceToken);
    }

    public void OnVaxNewTokenPushKit(String sDeviceToken)
    {
        VaxUserAgentSIP.OnVaxRegisterNewTokenPushKit(sDeviceToken);
    }

    public void OnVaxFailedPushKit()
    {
        VaxUserAgentSIP.OnVaxRegisterFailedPushKit();
    }

    public void OnVaxNotificationPushKit(String sCallerName, String sCallerId)
    {
        VaxUserAgentSIP.OnVaxNotificationPushKit(sCallerName, sCallerId);
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public boolean SpeakerPhone(boolean bEnable)
    {
        return mAudioDevice.SpeakerPhone(bEnable);
    }

    public boolean IsSpeakerPhone()
    {
        return mAudioDevice.IsSpeakerPhone();
    }

    public boolean DialCall(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo, int nInputDeviceId, int nOutputDeviceId)
    {
        if(!super.DialCall(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo, nInputDeviceId, nOutputDeviceId))
            return false;

        mAudioDevice.StartTimer();
        return true;
    }

    public boolean AcceptCall(int nLineNo, String sCallId, int nInputDeviceId, int nOutputDeviceId)
    {
        if(!super.AcceptCall(nLineNo, sCallId, nInputDeviceId, nOutputDeviceId))
            return false;

        mAudioDevice.StartTimer();
        return true;
    }

    public boolean DisconnectCall(int nLineNo)
    {
        boolean bResult = super.DisconnectCall(nLineNo);

        if(!super.IsLineBusy(-1))
            mAudioDevice.StopTimer();

        return bResult;
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void OnInitialized()
    {
        VaxUserAgentSIP.OnInitialized();
    }

    @Override
    public void OnUnInitialized()
    {
        VaxUserAgentSIP.OnUnInitialized();
    }

    @Override
    public void OnConnectingToRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnConnectingToRegister(sAccountName);
    }

    @Override
    public void OnTryingToRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnTryingToRegister(sAccountName);
    }

    @Override
    public void OnFailToRegister(String sAccountName, int nStatusCode, String sReasonPhrase)
    {
        VaxUserAgentSIP.OnFailToRegister(sAccountName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnSuccessToRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnSuccessToRegister(sAccountName);
    }

    @Override
    public void OnConnectingToReRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnConnectingToReRegister(sAccountName);
    }

    @Override
    public void OnTryingToReRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnTryingToReRegister(sAccountName);
    }

    @Override
    public void OnFailToReRegister(String sAccountName, int nStatusCode, String sReasonPhrase)
    {
        VaxUserAgentSIP.OnFailToReRegister(sAccountName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnSuccessToReRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnSuccessToReRegister(sAccountName);
    }

    @Override
    public void OnTryingToUnRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnTryingToUnRegister(sAccountName);
    }

    @Override
    public void OnFailToUnRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnFailToUnRegister(sAccountName);
    }

    @Override
    public void OnSuccessToUnRegister(String sAccountName)
    {
        VaxUserAgentSIP.OnSuccessToUnRegister(sAccountName);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void OnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo)
    {
        VaxUserAgentSIP.OnDialCallStarted(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo);
    }

    @Override
    public void OnDialingCall(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase)
    {
        VaxUserAgentSIP.OnDialingCall(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact)
    {
        VaxUserAgentSIP.OnDialCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase, sContact);
    }

    @Override
    public void OnConnectedCall(String sAccountName, int nLineNo, String sToAddrRTP, int nToPortRTP)
    {
        VaxUserAgentSIP.OnConnectedCall(sAccountName, nLineNo, sToAddrRTP, nToPortRTP);
    }

    @Override
    public void OnHungupCall(String sAccountName, int nLineNo)
    {
        if(!super.IsLineBusy(-1))
            mAudioDevice.StopTimer();

        VaxUserAgentSIP.OnHungupCall(sAccountName, nLineNo);
    }

    @Override
    public void OnIncomingCallStarted(String sAccountName, String sCallId, String sCallerName, String sCallerId, String sDialNo, String sFromURI, String sToURI)
    {
        VaxUserAgentSIP.OnIncomingCallStarted(sAccountName, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI);
    }

    @Override
    public void OnIncomingCallEnded(String sAccountName, String sCallId, int nReasonCode)
    {
        VaxUserAgentSIP.OnIncomingCallEnded(sAccountName, sCallId, nReasonCode);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void OnTransferCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase)
    {
        VaxUserAgentSIP.OnTransferCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnTransferCallAccepted(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnTransferCallAccepted(sAccountName, nLineNo);
    }

    @Override
    public void OnPlayWaveDone(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnPlayWaveDone(sAccountName, nLineNo);
    }

    @Override
    public void OnDigitDTMF(String sAccountName, int nLineNo, String sDigit)
    {
        VaxUserAgentSIP.OnDigitDTMF(sAccountName, nLineNo, sDigit);
    }

    @Override
    public void OnMsgNOTIFY(String sAccountName, String sMsg)
    {
        VaxUserAgentSIP.OnMsgNOTIFY(sAccountName, sMsg);
    }

    @Override
    public void OnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount)
    {
        VaxUserAgentSIP.OnVoiceMailMsg(sAccountName, bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
    }

    @Override
    public void OnRingToneStarted(String sAccountName, String sCallId)
    {
        VaxUserAgentSIP.OnRingToneStarted(sAccountName, sCallId);
    }

    @Override
    public void OnRingToneEnded(String sAccountName, String sCallId)
    {
        VaxUserAgentSIP.OnRingToneEnded(sAccountName, sCallId);
    }

    @Override
    public void OnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort)
    {
        VaxUserAgentSIP.OnIncomingDiagnostic(sAccountName, sMsgSIP, sFromIP, nFromPort);
    }

    @Override
    public void OnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort)
    {
        VaxUserAgentSIP.OnOutgoingDiagnostic(sAccountName, sMsgSIP, sToIP, nToPort);
    }

    @Override
    public void OnAudioSessionLost(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnAudioSessionLost(sAccountName, nLineNo);
    }

    @Override
    public void OnSuccessToHold(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnSuccessToHold(sAccountName, nLineNo);
    }

    @Override
    public void OnTryingToHold(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnTryingToHold(sAccountName, nLineNo);
    }

    @Override
    public void OnFailToHold(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnFailToHold(sAccountName, nLineNo);
    }

    @Override
    public void OnSuccessToUnHold(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnSuccessToUnHold(sAccountName, nLineNo);
    }

    @Override
    public void OnTryingToUnHold(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnTryingToUnHold(sAccountName, nLineNo);
    }

    @Override
    public void OnFailToUnHold(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnFailToUnHold(sAccountName, nLineNo);
    }

    @Override
    public void OnTryingToRefresh(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnTryingToRefresh(sAccountName, nLineNo);
    }

    @Override
    public void OnFailToRefresh(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnFailToRefresh(sAccountName, nLineNo);
    }

    @Override
    public void OnSuccessToRefresh(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnSuccessToRefresh(sAccountName, nLineNo);
    }

    @Override
    public void OnChatSubscribeSuccess(String sAccountName, String sUserName)
    {
        VaxUserAgentSIP.OnChatSubscribeSuccess(sAccountName, sUserName);
    }

    @Override
    public void OnChatSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase)
    {
        VaxUserAgentSIP.OnChatSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnChatContactStatus(String sAccountName, String sUserName, int nStatusId)
    {
        VaxUserAgentSIP.OnChatContactStatus(sAccountName, sUserName, nStatusId);
    }

    @Override
    public void OnChatSendMsgTextSuccess(String sAccountName, String sUserName, String sMsgText, int nUserValue)
    {
        VaxUserAgentSIP.OnChatSendMsgTextSuccess(sAccountName, sUserName, sMsgText, nUserValue);
    }

    @Override
    public void OnChatSendMsgTextFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue)
    {
        VaxUserAgentSIP.OnChatSendMsgTextFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue);
    }

    @Override
    public void OnChatSendMsgTypingSuccess(String sAccountName, String sUserName, int nUserValue)
    {
        VaxUserAgentSIP.OnChatSendMsgTypingSuccess(sAccountName, sUserName, nUserValue);
    }

    @Override
    public void OnChatSendMsgTypingFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue)
    {
        VaxUserAgentSIP.OnChatSendMsgTypingFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, nUserValue);
    }

    @Override
    public void OnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact)
    {
        VaxUserAgentSIP.OnChatRecvMsgText(sAccountName, sUserName, sMsgText, bIsChatContact);
    }

    @Override
    public void OnChatRecvMsgTypingStart(String sAccountName, String sUserName)
    {
        VaxUserAgentSIP.OnChatRecvMsgTypingStart(sAccountName, sUserName);
    }

    @Override
    public void OnChatRecvMsgTypingStop(String sAccountName, String sUserName)
    {
        VaxUserAgentSIP.OnChatRecvMsgTypingStop(sAccountName, sUserName);
    }

    @Override
    public void OnAudioRecordedPCM(String sAccountName, int nLineNo, byte[] aDataPCM, int nSizePCM, int nTypePCM)
    {
        VaxUserAgentSIP.OnAudioRecordedPCM(sAccountName, nLineNo, aDataPCM, nSizePCM, nTypePCM);
    }

    @Override
    public void OnHoldCall(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnHoldCall(sAccountName, nLineNo);
    }

    @Override
    public void OnUnHoldCall(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnUnHoldCall(sAccountName, nLineNo);
    }

    @Override
    public void OnVideoRemoteStarted(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnVideoRemoteStarted(sAccountName, nLineNo);
    }

    @Override
    public void OnVideoRemoteEnded(String sAccountName, int nLineNo)
    {
        VaxUserAgentSIP.OnVideoRemoteEnded(sAccountName, nLineNo);
    }

    @Override
    public void OnVideoDeviceFrameRGB(int nDeviceId, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
    {
        VaxUserAgentSIP.OnVideoDeviceFrameRGB(nDeviceId, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
    }

    @Override
    public void OnVideoRemoteFrameRGB(String sAccountName, int nLineNo, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
    {
        VaxUserAgentSIP.OnVideoRemoteFrameRGB(sAccountName, nLineNo, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
    }

    @Override
    public void OnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId)
    {
        VaxUserAgentSIP.OnAddCallHistory(sAccountName, bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
    }

    @Override
    public void OnNetworkReachability(boolean bAvailable)
    {
        VaxUserAgentSIP.OnNetworkReachability(bAvailable);
    }

    @Override
    public void OnAudioDeviceMicVU(int nLevelVU)
    {
        VaxUserAgentSIP.OnAudioDeviceMicVU(nLevelVU);
    }

    @Override
    public void OnAudioDeviceSpkVU(int nLevelVU)
    {
        VaxUserAgentSIP.OnAudioDeviceSpkVU(nLevelVU);
    }

    @Override
    public void OnBusyLampSubscribeSuccess(String sAccountName, String sUserName)
    {
        VaxUserAgentSIP.OnBusyLampSubscribeSuccess(sAccountName, sUserName);
    }

    @Override
    public void OnBusyLampSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase)
    {
        VaxUserAgentSIP.OnBusyLampSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
    }

    @Override
    public void OnBusyLampContactStatus(String sAccountName, String sUserName, int nStatusId)
    {
        VaxUserAgentSIP.OnBusyLampContactStatus(sAccountName, sUserName, nStatusId);
    }

    @Override
    public void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode)
    {
        VaxUserAgentSIP.OnVaxErrorMsg(sFuncName, sErrorMsg, nErrorCode);
    }
}
