package com.vaxsoft.vaxphonesip.VaxUserAgentSIP;

import java.util.ArrayList;
import android.content.Context;

import com.vaxsoft.vaxphonesip.VaxMainAPP.VaxPhoneAPP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.IVaxUserAgentSIP;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxCallInfo.VaxCallInfo;
import com.vaxsoft.vaxphonesip.VaxUserAgentSIP.VaxUserAgentLibSIP;

public class VaxUserAgentSIP
{
    public static final String VAX_TRIAL_LICENSE_KEY = "TRIAL-LICENSE-KEY";

    public static final int VAX_ACCOUNT_TYPE_UDP = 0;
    public static final int VAX_ACCOUNT_TYPE_TCP = 1;
    public static final int VAX_ACCOUNT_TYPE_TLS = 2;

    public static final int VAX_CAPTURE_SOUND_DEVICE_NONE = -2;

    public static final int VAX_VIDEO_QUALITY_LOW = 0;
    public static final int VAX_VIDEO_QUALITY_STANDARD = 1;
    public static final int VAX_VIDEO_QUALITY_MEDIUM = 2;
    public static final int VAX_VIDEO_QUALITY_HIGH = 3;
    public static final int VAX_VIDEO_QUALITY_MAX = 4;

    public static final int VAX_AUDIO_CODEC_G711U = 0;
    public static final int VAX_AUDIO_CODEC_G711A = 1;
    public static final int VAX_AUDIO_CODEC_GSM610 = 2;
    public static final int VAX_AUDIO_CODEC_ILBC = 3;
    public static final int VAX_AUDIO_CODEC_G729 = 4;
    public static final int VAX_AUDIO_CODEC_TOTAL = 5;

    public static final int VAX_VIDEO_CODEC_VP8 = 0;
    public static final int VAX_VIDEO_CODEC_TOTAL = 1;

    public static final int VAX_DTMF_TYPE_AUTO = 0;
    public static final int VAX_DTMF_TYPE_RFC2833 = 1;
    public static final int VAX_DTMF_TYPE_SIP_INFO = 2;
    public static final int VAX_DTMF_TYPE_INBAND = 3;

    public static final int VAX_CONTACT_STATUS_ONLINE = 0;
    public static final int VAX_CONTACT_STATUS_OFFLINE = 1;
    public static final int VAX_CONTACT_STATUS_AWAY = 2;
    public static final int VAX_CONTACT_STATUS_ON_PHONE = 3;
    public static final int VAX_CONTACT_STATUS_BUSY = 4;
    public static final int VAX_CONTACT_STATUS_UNKNOWN = 5;

    public static final int VAX_BUSY_LAMP_STATUS_FREE = 0;
    public static final int VAX_BUSY_LAMP_STATUS_OFFLINE = 1;
    public static final int VAX_BUSY_LAMP_STATUS_BUSY = 2;
    public static final int VAX_BUSY_LAMP_STATUS_UNKNOWN = 3;

    public static final int VAX_CALL_HISTORY_TYPE_OUTBOUND = 0;
    public static final int VAX_CALL_HISTORY_TYPE_INBOUND = 1;
    public static final int VAX_CALL_HISTORY_TYPE_MISSED = 2;
    public static final int VAX_CALL_HISTORY_TYPE_REJECTED = 3;

    /////////////////////////////////////////////////////////////////////////////////////

    static private VaxUserAgentLibSIP mVaxAgentLibSIP = null;
    static private ArrayList<IVaxUserAgentSIP> mListInterface = null;

    static private boolean mLicenceKeyTypeTrial = true;

    /////////////////////////////////////////////////////////////////////////////////////

    private IVaxUserAgentSIP mIVaxUserAgentSIP = null;

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public VaxUserAgentSIP(IVaxUserAgentSIP iVaxUserAgentSIP)
    {
        mIVaxUserAgentSIP = iVaxUserAgentSIP;

        if(mVaxAgentLibSIP == null)
        {
            mVaxAgentLibSIP = new VaxUserAgentLibSIP(VaxPhoneAPP.GetContextAPP());
        }

        if(mListInterface == null)
        {
            mListInterface = new ArrayList<>();
        }

        if(mIVaxUserAgentSIP != null)
            mListInterface.add(mIVaxUserAgentSIP);
    }

    protected void finalize() throws Throwable
    {
        if(mIVaxUserAgentSIP == null)
            return;

        if(mListInterface != null)
            mListInterface.remove(mIVaxUserAgentSIP);

        mIVaxUserAgentSIP = null;
    }

    public boolean SpeakerPhone(boolean bEnable)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.SpeakerPhone(bEnable);
    }

    public boolean IsSpeakerPhone()
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.IsSpeakerPhone();
    }

    ////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////

    public static boolean IsLicenceKeyTrial()
    {
        return mLicenceKeyTypeTrial;
    }

    public boolean SetLicenceKey(String sKey)
    {
        if(sKey == VaxUserAgentSIP.VAX_TRIAL_LICENSE_KEY || sKey.isEmpty())
            mLicenceKeyTypeTrial = true;
        else
            mLicenceKeyTypeTrial = false;

        return VaxUserAgentSIP.mVaxAgentLibSIP.SetLicenceKey(sKey);
    }

    public boolean Initialize()
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.Initialize();
    }

    public void UnInitialize()
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.UnInitialize();
    }

    public boolean DiagnosticLogSIP(String sAccountName, boolean bInbound, boolean bOutbound)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.DiagnosticLogSIP(sAccountName, bInbound, bOutbound);
    }

    public boolean AddAccountSIP(String sAccountName, int nAccountType, String sListenIP, int nListenPort, String sDisplayName, String sUserName, String sAuthLogin, String sAuthPwd, String sDomainRealm, String sServerAddr, int nServerPort)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.AddAccountSIP(sAccountName, nAccountType, sListenIP, nListenPort, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort);
    }

    public void RemoveAccountSIP(String sAccountName)
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.RemoveAccountSIP(sAccountName);
    }

    public boolean DialCall(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DialCall(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo, -1, -1);
    }

    public boolean DialCallToREC(String sAccountName, int nLineNo, String sDialNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DialCallToREC(sAccountName, nLineNo, sDialNo);
    }

    public boolean DisconnectCall(int nLineNo)
    {
	    if(!VaxUserAgentSIP.mVaxAgentLibSIP.DisconnectCall(nLineNo))
	        return false;

	    VaxUserAgentSIP.OnDisconnectedCall(nLineNo);
	    return true;
    }

    public boolean AcceptCall(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AcceptCall(nLineNo, "", -1, -1);
    }

    public boolean RejectCall()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.RejectCall("");
    }

    public boolean TransferCallBlind(int nLineNo, String sToUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.TransferCallBlind(nLineNo, sToUserName);
    }

    public boolean TransferCallConsult(int nLineNoA, int nLineNoB)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.TransferCallConsult(nLineNoA, nLineNoB);
    }

    public boolean HoldLine(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.HoldLine(nLineNo);
    }

    public boolean UnHoldLine(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.UnHoldLine(nLineNo);
    }

    public boolean RefreshLine(int nLineNo)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.RefreshLine(nLineNo);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public boolean RegisterAccountPushKit(String sAccountName, int nExpire)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.RegisterAccountPushKit(sAccountName, nExpire);
    }

    public boolean RegisterAccountSIP(String sAccountName, int nExpire)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.RegisterAccountSIP(sAccountName, nExpire);
    }

    public boolean UnRegisterAccountSIP(String sAccountName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.UnRegisterAccountSIP(sAccountName);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    public boolean EnableKeepAlive(String sAccountName, int nSeconds)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.EnableKeepAlive(sAccountName, nSeconds);
    }

    public void DisableKeepAlive(String sAccountName)
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.DisableKeepAlive(sAccountName);
    }

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    public void DeselectAllAudioCodec()
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.DeselectAllAudioCodec();
    }

    public void SelectAllAudioCodec()
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.SelectAllAudioCodec();
    }

    public boolean SelectAudioCodec(int nCodecNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.SelectAudioCodec(nCodecNo);
    }

    public boolean DeselectAudioCodec(int nCodecNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DeselectAudioCodec(nCodecNo);
    }

//////////////////////////////////////////////////////////////////////////////

    public void DeselectAllVideoCodec()
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.DeselectAllVideoCodec();
    }

    public void SelectAllVideoCodec()
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.SelectAllVideoCodec();
    }

    public boolean SelectVideoCodec(int nCodecNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.SelectVideoCodec(nCodecNo);
    }

    public boolean DeselectVideoCodec(int nCodecNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DeselectVideoCodec(nCodecNo);
    }

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    public boolean OpenLineREC(int nLineNo, String sRTPRxIP, int nAudioPortRTP)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.OpenLineREC(nLineNo, sRTPRxIP, nAudioPortRTP);
    }

    public boolean OpenLine(int nLineNo, String sRTPRxIP, int nRxAudioPortRTP, int nRxVideoPortRTP)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.OpenLine(nLineNo, sRTPRxIP, nRxAudioPortRTP, nRxVideoPortRTP);
    }

    public boolean CloseLine(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.CloseLine(nLineNo);
    }

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    public boolean CryptoMediaNONE(boolean bForced)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.CryptoMediaNONE(bForced);
    }

    public boolean CryptoMediaSDP(boolean bForced)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.CryptoMediaSDP(bForced);
    }

    public int GetVaxErrorCode()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetVaxErrorCode();
    }

    public String GetVaxErrorMsg()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetVaxErrorMsg();
    }

    public boolean DigitDTMF(int nLineNo, String sDigit, int nTypeDTMF)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DigitDTMF(nLineNo, sDigit, nTypeDTMF);
    }

    public boolean SetVolumeDTMF(int nVolume)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.SetVolumeDTMF(nVolume);
    }

    public int GetVolumeDTMF()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetVolumeDTMF();
    }

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

    public boolean MuteMic(boolean bMute)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.MuteMic(bMute);
    }

    public boolean MuteSpk(boolean bMute)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.MuteSpk(bMute);
    }

    public boolean MuteLineSpk(int nLineNo, boolean bMute)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.MuteLineSpk(nLineNo, bMute);
    }

    public boolean MuteLineMic(int nLineNo, boolean bMute)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.MuteLineMic(nLineNo, bMute);
    }

    public boolean AutoGainMic(boolean bEnable, int nVolume)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AutoGainMic(bEnable, nVolume);
    }

    public boolean AutoGainSpk(boolean bEnable, int nVolume)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AutoGainSpk(bEnable, nVolume);
    }

    public boolean SetVolumeMic(int nVolume)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.SetVolumeMic(nVolume);
    }

    public int GetVolumeMic()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetVolumeMic();
    }

    public boolean SetVolumeSpk(int nVolume)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.SetVolumeSpk(nVolume);
    }

    public int GetVolumeSpk()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetVolumeSpk();
    }

    public boolean SetLineVolumeSpk(int nLineNo, int nVolume)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.SetLineVolumeSpk(nLineNo, nVolume);
    }

    public int GetLineVolumeSpk(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetLineVolumeSpk(nLineNo);
    }

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

    public boolean IsLineOpen(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.IsLineOpen(nLineNo);
    }

    public boolean IsLineHold(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.IsLineHold(nLineNo);
    }

    public boolean IsLineBusy(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.IsLineBusy(nLineNo);
    }

    public boolean IsLineConnected(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.IsLineConnected(nLineNo);
    }

    public boolean IsLineRecording(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.IsLineRecording(nLineNo);
    }

    public boolean StartRecording(int nLineNo, String sFileName, int nTypeRecord, int nTypePCM)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.StartRecording(nLineNo, sFileName, nTypeRecord, nTypePCM);
    }

    public boolean StopRecording(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.StopRecording(nLineNo);
    }

    public boolean ResetRecording(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ResetRecording(nLineNo);
    }

    public boolean IsLinePlaying(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.IsLinePlaying(nLineNo);
    }

    public boolean PlayWaveOpen(int nLineNo, String sFileName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWaveOpen(nLineNo, sFileName);
    }

    public boolean PlayWaveClose(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWaveClose(nLineNo);
    }

    public boolean PlayWaveSkipTo(int nLineNo, int nMilliSeconds)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWaveSkipTo(nLineNo, nMilliSeconds);
    }

    public int PlayWaveTotalTime(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWaveTotalTime(nLineNo);
    }

    public boolean PlayWavePause(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWavePause(nLineNo);
    }

    public boolean PlayWaveStart(int nLineNo, boolean bListen)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWaveStart(nLineNo, bListen);
    }

    public boolean PlayWaveStop(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWaveStop(nLineNo);
    }

    public int PlayWavePosition(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.PlayWavePosition(nLineNo);
    }

    public boolean EchoCancellation(boolean bEnable)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.EchoCancellation(bEnable);
    }

    public boolean DonotDisturb(boolean bEnable)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DonotDisturb(bEnable);
    }

    public boolean AudioDeviceVU(boolean bActivate, boolean bMicVU, boolean bSpkVU)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AudioDeviceVU(bActivate, bMicVU, bSpkVU);
    }

    public int GetAudioInDevTotal()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetAudioInDevTotal();
    }

    public int GetAudioOutDevTotal()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetAudioOutDevTotal();
    }

    public String GetAudioOutDevName(int nDeviceId)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetAudioOutDevName(nDeviceId);
    }

    public String GetAudioInDevName(int nDeviceId)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetAudioInDevName(nDeviceId);
    }

    public int GetOutboundCodec(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetOutboundCodec(nLineNo);
    }

    public int GetInboundCodec(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetInboundCodec(nLineNo);
    }

    public boolean AudioSessionLost(int nSeconds)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AudioSessionLost(nSeconds);
    }

    public boolean SetUserAgentSIP(String sUserAgentName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.SetUserAgentSIP(sUserAgentName);
    }

    public String GetUserAgentSIP()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetUserAgentSIP();
    }

    public boolean SetSubjectSDP(String sSubjectSDP)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.SetSubjectSDP(sSubjectSDP);
    }

    public String GetSubjectSDP()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetSubjectSDP();
    }

    public boolean ConfAllowLine(int nLineNo, boolean bAllowListen, boolean bAllowSpeak)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.ConfAllowLine(nLineNo, bAllowListen, bAllowSpeak);
    }

    public boolean ChatFindContact(String sAccountName, String sUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ChatFindContact(sAccountName, sUserName);
    }

    public boolean ChatAddContact(String sAccountName, String sUserName, boolean bPresence)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ChatAddContact(sAccountName, sUserName, bPresence);
    }

    public boolean ChatRemoveContact(String sAccountName, String sUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ChatRemoveContact(sAccountName, sUserName);
    }

    public boolean ChatSendMessageTyping(String sAccountName, String sUserName, int nUserValue)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ChatSendMessageTyping(sAccountName, sUserName, nUserValue);
    }

    public boolean ChatSendMessageText(String sAccountName, String sUserName, String sMsgText, boolean bMsgTypeHtml, int nUserValue)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ChatSendMessageText(sAccountName, sUserName, sMsgText, bMsgTypeHtml, nUserValue);
    }

    public boolean ChatSubscribeContactAll(String sAccountName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ChatSubscribeContactAll(sAccountName);
    }

    public boolean ChatSetMyStatus(String sAccountName, int nStatusId)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ChatSetMyStatus(sAccountName, nStatusId);
    }

    public boolean VoiceChanger(int nPitch)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.VoiceChanger(nPitch);
    }

    public boolean ForwardCall(boolean bEnable, String sToUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.ForwardCall(bEnable, sToUserName);
    }

    public boolean AddCustomHeader(int nLineNo, int nReqId, String sName, String sValue)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AddCustomHeader(nLineNo, nReqId, sName, sValue);
    }

    public boolean RemoveCustomHeader(int nLineNo, int nReqId, String sName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.RemoveCustomHeader(nLineNo, nReqId, sName);
    }

    public boolean RemoveCustomHeaderAll(int nLineNo, int nReqId)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.RemoveCustomHeaderAll(nLineNo, nReqId);
    }

    public boolean AddCustomHeaderReferToURI(String sName, String sValue)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AddCustomHeaderReferToURI(sName, sValue);
    }

    public boolean RemoveCustomHeaderReferToURI(String sName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.RemoveCustomHeaderReferToURI(sName);
    }

    public boolean RemoveCustomHeaderAllReferToURI()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.RemoveCustomHeaderAllReferToURI();
    }

    public int GetCountPacketLost(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetCountPacketLost(nLineNo);
    }

    public int GetSizeJitterBuffer(int nLineNo)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetSizeJitterBuffer(nLineNo);
    }
    
    public int GetVideoDevTotal()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetVideoDevTotal();
    }

    public String GetVideoDevName(int nDeviceId)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.GetVideoDevName(nDeviceId);
    }

    public boolean OpenVideoDev(int nDeviceId, int nQuality)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.OpenVideoDev(nDeviceId, nQuality);
    }

    public void CloseVideoDev()
    {
        VaxUserAgentSIP.mVaxAgentLibSIP.CloseVideoDev();
    }

////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

    public boolean DialRingEnable(String sFileName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DialRingEnable(sFileName);
    }

    public boolean DialRingDisable()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.DialRingDisable();
    }

    public boolean BusyRingEnable(String sFileName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.BusyRingEnable(sFileName);
    }

    public boolean BusyRingDisable()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.BusyRingDisable();
    }

    public boolean EnableVideo(int nLineNo, boolean bOutbound, boolean bInbound)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.EnableVideo(nLineNo, bOutbound, bInbound);
    }

    public boolean IsNetworkAvailable()
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.IsNetworkAvailable();
    }

    public boolean NetworkReachability(boolean bEnable)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.NetworkReachability(bEnable);
    }

    public boolean AutoRegistration(String sAccountName, boolean bEnable, int nTickCountLimit, int nTickSeconds)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.AutoRegistration(sAccountName, bEnable, nTickCountLimit, nTickSeconds);
    }

    public boolean VideoCodecBitRate(int nCodecNo, int nQuality)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.VideoCodecBitRate(nCodecNo, nQuality);
    }

    public int BusyLampGetContactStatus(String sAccountName, String sUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.BusyLampGetContactStatus(sAccountName, sUserName);
    }

    public boolean BusyLampFindContact(String sAccountName, String sUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.BusyLampFindContact(sAccountName, sUserName);
    }

    public boolean BusyLampAddContact(String sAccountName, String sUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.BusyLampAddContact(sAccountName, sUserName);
    }

    public boolean BusyLampRemoveContact(String sAccountName, String sUserName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.BusyLampRemoveContact(sAccountName, sUserName);
    }

    public boolean BusyLampSubscribeContactAll(String sAccountName)
    {
	    return VaxUserAgentSIP.mVaxAgentLibSIP.BusyLampSubscribeContactAll(sAccountName);
    }

    public boolean SetPushSIP(String sAccountName, String sProjectId, String sTokenReg)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.SetPushSIP(sAccountName, sProjectId, sTokenReg);
    }

    public boolean AudioVAD(int nLineNo, boolean bEnable)
    {
        return VaxUserAgentSIP.mVaxAgentLibSIP.AudioVAD(nLineNo, bEnable);
    }

    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////


    ////////////////////////////////////////////////////////////////////
    //////////////////////    EVENTS      //////////////////////////////
    ///////////////////////////////////////////////////////////////////

    static public void OnInitialized()
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnInitialized();
        }
    }

    static public void OnUnInitialized()
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnUnInitialized();
        }
    }

    static public void OnConnectingToRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnConnectingToRegister(sAccountName);
        }
    }

    static public void OnTryingToRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTryingToRegister(sAccountName);
        }
    }

    static public void OnFailToRegister(String sAccountName, int nStatusCode, String sReasonPhrase)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnFailToRegister(sAccountName, nStatusCode, sReasonPhrase);
        }
    }

    static public void OnSuccessToRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnSuccessToRegister(sAccountName);
        }
    }

    static public void OnConnectingToReRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnConnectingToReRegister(sAccountName);
        }
    }

    static public void OnTryingToReRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTryingToReRegister(sAccountName);
        }
    }

    static public void OnFailToReRegister(String sAccountName, int nStatusCode, String sReasonPhrase)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnFailToReRegister(sAccountName, nStatusCode, sReasonPhrase);
        }
    }

    static public void OnSuccessToReRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnSuccessToReRegister(sAccountName);
        }
    }

    static public void OnTryingToUnRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTryingToUnRegister(sAccountName);
        }
    }

    static public void OnFailToUnRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnFailToUnRegister(sAccountName);
        }
    }

    static public void OnSuccessToUnRegister(String sAccountName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnSuccessToUnRegister(sAccountName);
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    static public void OnDialCallStarted(String sAccountName, int nLineNo, String sCallerName, String sCallerId, String sDialNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnDialCallStarted(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo);
        }
    }

    static public void OnDialingCall(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnDialingCall(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
        }
    }

    static public void OnDialCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase, String sContact)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnDialCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase, sContact);
        }
    }

    static public void OnConnectedCall(String sAccountName, int nLineNo, String sToAddrRTP, int nToPortRTP)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnConnectedCall(sAccountName, nLineNo, sToAddrRTP, nToPortRTP);
        }
    }

    static public void OnHungupCall(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnHungupCall(sAccountName, nLineNo);
        }
    }

    static public void OnDisconnectedCall(int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnDisconnectedCall(nLineNo);
        }
    }

    static public void OnIncomingCallStarted(String sAccountName, String sCallId, String sCallerName, String sCallerId, String sDialNo, String sFromURI, String sToURI)
    {
        StringBuilder sResultCallerName = new StringBuilder();
        StringBuilder sResultCallerId = new StringBuilder();
        StringBuilder sResultContactId = new StringBuilder();

        VaxCallInfo.PrepareCallInfo(sCallerName, sCallerId, sResultCallerName, sResultCallerId, sResultContactId);

        sCallerName = sResultCallerName.toString();
        sCallerId = sResultCallerId.toString();

        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnIncomingCallStarted(sAccountName, sCallerName, sCallerId);
        }
    }

    static public void OnIncomingCallEnded(String sAccountName, String sCallId, int nReasonCode)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnIncomingCallEnded(sAccountName, nReasonCode);
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    static public void OnTransferCallFailed(String sAccountName, int nLineNo, int nStatusCode, String sReasonPhrase)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTransferCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase);
        }
    }

    static public void OnTransferCallAccepted(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTransferCallAccepted(sAccountName, nLineNo);
        }
    }

    static public void OnPlayWaveDone(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnPlayWaveDone(sAccountName, nLineNo);
        }
    }

    static public void OnDigitDTMF(String sAccountName, int nLineNo, String sDigit)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnDigitDTMF(sAccountName, nLineNo, sDigit);
        }
    }

    static public void OnMsgNOTIFY(String sAccountName, String sMsg)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnMsgNOTIFY(sAccountName, sMsg);
        }
    }

    static public void OnVoiceMailMsg(String sAccountName, boolean bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVoiceMailMsg(sAccountName, bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
        }
    }

    static public void OnRingToneStarted(String sAccountName, String sCallId)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnRingToneStarted(sAccountName);
        }
    }

    static public void OnRingToneEnded(String sAccountName, String sCallId)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnRingToneEnded(sAccountName);
        }
    }

    static public void OnIncomingDiagnostic(String sAccountName, String sMsgSIP, String sFromIP, int nFromPort)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnIncomingDiagnostic(sAccountName, sMsgSIP, sFromIP, nFromPort);
        }
    }

    static public void OnOutgoingDiagnostic(String sAccountName, String sMsgSIP, String sToIP, int nToPort)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnOutgoingDiagnostic(sAccountName, sMsgSIP, sToIP, nToPort);
        }
    }

    static public void OnAudioSessionLost(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnAudioSessionLost(sAccountName, nLineNo);
        }
    }

    static public void OnSuccessToHold(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnSuccessToHold(sAccountName, nLineNo);
        }
    }

    static public void OnTryingToHold(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTryingToHold(sAccountName, nLineNo);
        }
    }

    static public void OnFailToHold(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnFailToHold(sAccountName, nLineNo);
        }
    }

    static public void OnSuccessToUnHold(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnSuccessToUnHold(sAccountName, nLineNo);
        }
    }

    static public void OnTryingToUnHold(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTryingToUnHold(sAccountName, nLineNo);
        }
    }

    static public void OnFailToUnHold(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnFailToUnHold(sAccountName, nLineNo);
        }
    }

    static public void OnTryingToRefresh(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnTryingToRefresh(sAccountName, nLineNo);
        }
    }

    static public void OnFailToRefresh(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnFailToRefresh(sAccountName, nLineNo);
        }
    }

    static public void OnSuccessToRefresh(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnSuccessToRefresh(sAccountName, nLineNo);
        }
    }

    static public void OnChatSubscribeSuccess(String sAccountName, String sUserName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatSubscribeSuccess(sAccountName, sUserName);
        }
    }

    static public void OnChatSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
        }
    }

    static public void OnChatContactStatus(String sAccountName, String sUserName, int nStatusId)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatContactStatus(sAccountName, sUserName, nStatusId);
        }
    }

    static public void OnChatSendMsgTextSuccess(String sAccountName, String sUserName, String sMsgText, int nUserValue)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatSendMsgTextSuccess(sAccountName, sUserName, sMsgText, nUserValue);
        }
    }

    static public void OnChatSendMsgTextFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatSendMsgTextFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue);
        }
    }

    static public void OnChatSendMsgTypingSuccess(String sAccountName, String sUserName, int nUserValue)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatSendMsgTypingSuccess(sAccountName, sUserName, nUserValue);
        }
    }

    static public void OnChatSendMsgTypingFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatSendMsgTypingFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, nUserValue);
        }
    }

    static public void OnChatRecvMsgText(String sAccountName, String sUserName, String sMsgText, boolean bIsChatContact)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatRecvMsgText(sAccountName, sUserName, sMsgText, bIsChatContact);
        }
    }

    static public void OnChatRecvMsgTypingStart(String sAccountName, String sUserName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatRecvMsgTypingStart(sAccountName, sUserName);
        }
    }

    static public void OnChatRecvMsgTypingStop(String sAccountName, String sUserName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnChatRecvMsgTypingStop(sAccountName, sUserName);
        }
    }

    static public void OnAudioRecordedPCM(String sAccountName, int nLineNo, byte[] aDataPCM, int nSizePCM, int nTypePCM)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnAudioRecordedPCM(sAccountName, nLineNo, aDataPCM, nSizePCM, nTypePCM);
        }
    }

    static public void OnHoldCall(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnHoldCall(sAccountName, nLineNo);
        }
    }

    static public void OnUnHoldCall(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnUnHoldCall(sAccountName, nLineNo);
        }
    }

    static public void OnVideoRemoteStarted(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVideoRemoteStarted(sAccountName, nLineNo);
        }
    }

    static public void OnVideoRemoteEnded(String sAccountName, int nLineNo)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVideoRemoteEnded(sAccountName, nLineNo);
        }
    }

    static public void OnVideoDeviceFrameRGB(int nDeviceId, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVideoDeviceFrameRGB(nDeviceId, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
        }
    }

    static public void OnVideoRemoteFrameRGB(String sAccountName, int nLineNo, byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVideoRemoteFrameRGB(sAccountName, nLineNo, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
        }
    }

    static public void OnAddCallHistory(String sAccountName, boolean bOutboundCallType, String sCallerName, String sCallerId, String sDialNo, long nStartTime, long nEndTime, long nDuration, long nDayNo, int nHistoryTypeId)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnAddCallHistory(sAccountName, bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
        }
    }

    static public void OnNetworkReachability(boolean bAvailable)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnNetworkReachability(bAvailable);
        }
    }

    static public void OnAudioDeviceMicVU(int nLevelVU)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnAudioDeviceMicVU(nLevelVU);
        }
    }

    static public void OnAudioDeviceSpkVU(int nLevelVU)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnAudioDeviceSpkVU(nLevelVU);
        }
    }

    static public void OnBusyLampSubscribeSuccess(String sAccountName, String sUserName)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnBusyLampSubscribeSuccess(sAccountName, sUserName);
        }
    }

    static public void OnBusyLampSubscribeFailed(String sAccountName, String sUserName, int nStatusCode, String sReasonPhrase)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnBusyLampSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase);
        }
    }

    static public void OnBusyLampContactStatus(String sAccountName, String sUserName, int nStatusId)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnBusyLampContactStatus(sAccountName, sUserName, nStatusId);
        }
    }

    static public void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVaxErrorMsg(sFuncName, sErrorMsg, nErrorCode);
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    static public void OnVaxRegisterTryingPushKit()
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVaxRegisterTryingPushKit();
        }
    }

    static public void OnVaxRegisterFailedPushKit()
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVaxRegisterFailedPushKit();
        }
    }

    static public void OnVaxRegisterSuccessPushKit(String sDeviceToken)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVaxRegisterSuccessPushKit(sDeviceToken);
        }
    }

    static public void OnVaxRegisterNewTokenPushKit(String sDeviceToken)
    {
        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnVaxRegisterNewTokenPushKit(sDeviceToken);
        }
    }

    static public void OnVaxNotificationPushKit(String sCallerName, String sCallerId)
    {
        StringBuilder sResultCallerName = new StringBuilder();
        StringBuilder sResultCallerId = new StringBuilder();
        StringBuilder sResultContactId = new StringBuilder();

        VaxCallInfo.PrepareCallInfo(sCallerName, sCallerId, sResultCallerName, sResultCallerId, sResultContactId);

        sCallerName = sResultCallerName.toString();
        sCallerId = sResultCallerId.toString();

        for (int nCount = 0; nCount < mListInterface.size(); nCount++)
        {
            IVaxUserAgentSIP iVaxUserAgentSIP = mListInterface.get(nCount);
            iVaxUserAgentSIP.OnIncomingCallPushKit(sCallerName, sCallerId);
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////
}
